/*****************************************************
 *                                                   *
 *      File and Directory manipulater for OS/2      *
 *                                                   *
 *      Copyright (C) 1992-1996 by Nob_Kozawa        *
 *                                                   *
 *****************************************************/
 /* Added Altair's modification 92/10/31, 96/10/14, 96/11/-7 */
parse upper arg OPT1

/**********************************************************************/
 VER = '1.00C'; DATE = '97/03/17'; TITLE = '[ FD/2' VER '- Nob_Kozawa ]'
/**********************************************************************/

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs                           /* Load all rexx utilities */

NETMODE = 0; SPATH = ''
do forever     /* Command line options */
   P = pos('/',OPT1)
   if P = 0 then leave   /* no more option */
   OPT2 = word(substr(OPT1,P+1),1)
   if left(OPT2,3) = 'INI' then parse value OPT1 with . '=' INIPATH . '/' .
   if left(OPT2,1) = 'N' then NETMODE = 1
   if left(OPT2,1) = '?' then do
      say TITLE DATE
      say
      say 'Usage:  FD2 [path][/N][/nn][/INI=inipath][/?]'
      say '            path  : path name'
      say '            /N    : Telnet mode'
      say '            /nn   : nn = number of lines'
      say '            /INI= : ini file name'
      say '            /?    : Command line help'
      exit
   end  /* Do */
   if datatype(OPT2) = 'NUM' then OPT3 = OPT2
   SPATH = left(OPT1,P-1)
   parse value substr(OPT1,P) with . OPT1
end /* do */
if SPATH = '' then SPATH = OPT1
if datatype(OPT3) = 'NUM' then '@MODE CO80' OPT3
if OPT2 = 'DEBUG' then call DEBUGMODE

ORIGINAL = directory()                      /* save original directory */
/* Checking FD2.DLL */
  RC = RxFuncAdd('RXGETDEVPARM','FD2','RXGETDEVPARM')
  signal on SYNTAX name FD2DLLCHK
  call RXGETDEVPARM left(ORIGINAL,1)
  FD2DLL = 0
  signal FD2DLLOK
FD2DLLCHK:
  say 'FD2.DLL is not installed.'
  FD2DLL = 1
FD2DLLOK:

/* Setup */
/* signal on ERROR    name  ERROREXIT                 Trap for debug */
/* signal on FAILURE  name  ERROREXIT                  Trap for debug */
signal on SYNTAX   name  ERROREXIT                /* Trap for debug */
call on NOTREADY                                  /* Goto not ready for debug */

parse source . . PATH     /* Get path of FD/2 */
if symbol('INIPATH') = 'LIT' | INIPATH = '' then do
  INIPATH = left(PATH,LASTPOS('.',PATH))||'INI'  /* Build filename for ini file */
end  /* Do */
else do                   /* inipath was specified in command line option */
   options 'EXMODE'
   IDRV = filespec('Drive',INIPATH)
   IPATH = filespec('Path',INIPATH)
   INAME = filespec('Name',INIPATH)
   if IPATH = '' then do
      if IDRV = '' then IPATH = filespec('Path',ORIGINAL'\')
      else do
         IPATH = filespec('Path',directory(IDRV)||'\')
         call directory ORIGINAL
      end  /* Do */
   end  /* Do */
   if IDRV = '' then IDRV = left(ORIGINAL,2)
   if INAME = '' then do
      INAME = filespec('Name',PATH)
      INAME = left(INAME,lastpos('.',INAME) - 1)
   end
   if pos('.',INAME) = 0 then INAME = INAME||'.INI'
   INIPATH = IDRV||IPATH||INAME
   options 'NOEXMODE'
end  /* Do */

ORGPROMPT = value('PROMPT',,'OS2ENVIRONMENT') /* Save original prompt */
'@prompt'        /* HELP OFF */
CURRENT = directory(SPATH)                  /* change directory */

X = value('FD2VAR',NETMODE DEBUG DEBUGQ INIPATH FD2DLL ORGPROMPT,'OS2ENVIRONMENT')
X = value('FD2VER',VER DATE TITLE,'OS2ENVIRONMENT')

COLD_START:  /* Cold start point for HALT trap.  Ctrl+C or Ctrl+Break */
signal on HALT
drop DTREE.
RC = ' '
parse value value('FD2VAR',,'OS2ENVIRONMENT') with NETMODE DEBUG DEBUGQ INIPATH FD2DLL ORGPROMPT
parse value value('FD2VER',,'OS2ENVIRONMENT') with VER DATE TITLE

parse value SysTextScreenSize() with ROW COL .
call SETPARM          /* Setting up some fixed vaules */
HIST. = ''; HIST.0 = 0; ALIST = ''; ALIST. = ''; AUNPK = ''; AUNPK. = ''; CCLR. = ''

/*   ROW = 20; COL = 60 */
/*************************************
 * Default Configuration parameteres *
 * --------------------------------- *****************************
 * %a will replace with archive filename                         *
 * %d will replace with directory name (distination for extract) *
 * %f will replace with filename                                 *
 * if no %f specified, filename will append.                     *
 * i.e, 'LHA L' = 'LHA L %f'                                     *
 *****************************************************************/

   PM_EDITOR  = 'EPM'
   PM_VIEWER  = ''
   NET_EDITOR = 'TEDIT'
   NET_VIEWER = ''
   APACK      = 'ZIP %a %f'
   ALIST = 'ZIP LZH ZOO ARC INF'
   ALIST.1  = 'UNZIP -l'
   ALIST.2  = 'LHA L'
   ALIST.3  = 'ZOO l'
   ALIST.4  = 'FD2.BAT PKUNPAK -v'
   ALIST.5  = '@VIEW'
   AUNPK = 'ZIP LZH ZOO ARC DSK'
   AUNPK.1  = 'UNZIP %f -d %d'
   AUNPK.2  = 'LHA X %f %d'
   AUNPK.3  = 'ZOO x'
   AUNPK.4  = 'PKUNPAK'
   AUNPK.5  = 'LOADDSKF %f A:'
   DISPMODE   = 2     /* Choose 1, 1A, 1B, 1C, 2, 3 or 5 */
   DISPMODE1SAV = 1
   LONGNAMEMODE = 'ON'
   CDROMINDEX = 'ON'
   EACOMMENTS = 'ON'
   TREEFILE   = 'FD2TREE.DAT'
   /* COLOR SETUP */
   /* format : CCLR.n = [H]ff[bb]              */
   /*                    H  : High intensify   */
   /*                    ff : foreground color */
   /*                    bb : background color */
   /* Colors : BK=BLACK RE=READ GR=GREEN YE=YELLOW BL=BLUE    */
   /*          PU=PURPLE TU=TURQUOISE WH=WHITE RV=REVERSE     */
   CCLR.0 = '1B'x||'[0m'                 /* No attribute */
   CCLR.1 = 'WHBL'                         /* Frame */
   CCLR.2 = 'HYEBL'                        /* Infomation */
   CCLR.3 = 'PU'                           /* System file */
   CCLR.4 = 'BL'                           /* Hidden file */
   CCLR.5 = 'GR'                           /* Read only file */
   CCLR.6 = 'TU'                           /* Directory */
   CCLR.13 = 'BKPU'                        /* System file, Sel */
   CCLR.14 = 'BKBL'                        /* Hidden file, Sel */
   CCLR.15 = 'BKGR'                        /* Read only file, Sel */
   CCLR.16 = 'BKTU'                        /* Directory, Sel */
   CCLR.7 = 'HWH'                          /* No attrib file */
   CCLR.19 = 'RV'                          /* No attrib file, Sel */
   CCLR.8 = 'RETU'                         /* Mesage */
   CCLR.9 = 'WHBL'                         /* Shadow */
   CCLR.10= 'BLWH'                         /* Prompt */
   CCLR.11= 'WHBL'                         /* Input area */
   CCLR.12= 'BLTU'                         /* Selection */
   CCLR.17 = 'REBK'                        /* Not exsist */
   CCLR.18 = 'BKRE'                        /* Not exsist */
   CCLR.20 = 'HBLWH'                        /* Removal Drive */
   CCLR.21 = 'BKWH'                        /* Fixed Drive */
   CCLR.22 = 'HBLTU'                        /* Remote, Removal Drive */
   CCLR.23 = 'BKTU'                        /* Remote, Fixed Drive */
   call SETCOLOR 23

   call READINI   /* Read INI file */

   /* SET DISPlay Mode */
   call SETDISPM DISPMODE

   if NETMODE = 1 then do
      EDITOR = NET_EDITOR
      VIEWER = NET_VIEWER
   end  /* Do */
   else do
      EDITOR = PM_EDITOR
      VIEWER = PM_VIEWER
   end  /* Do */
/* End of definition ***********************************************/

CURRENT = directory()
if right(CURRENT,2) <> ':\' then CURRENT = CURRENT||'\'
call CLS                  /* Clear screen */
call DISPFRAME            /* DISPlay FRAME */
call GETFILES             /* GET current directory FILES */
call DISPFILE             /* DISPlay FILE field */
call DISPINFO             /* DISPlay INFOmation field */
SP = 0
/* Main loop */
  do forever
    parse upper value right(FNAME.INR,4) with . '.' EXT

    FPLIST.CURRENT = FNAME.INR; FPLIST.CURRENT.0 = NR; FPLIST.CURRENT.1 = FST

    if EXT = 'CMD' | EXT = 'EXE' | EXT = 'COM' | EXT = 'BAT' then EXTT = 1
    else EXTT = 0                       /* EXTT : 1 = executable, 0 = other */
    call SAYRC
    parse upper value sysgetkey('NOECHO') with CMD
    select
       when CMD = 'E0'X then SP = 1      /* Extended key code */
       when CMD = '00'X then SP = 2      /* alt key code */
       otherwise SP = 0
    end
    if SP <> 0 then parse upper value sysgetkey('NOECHO') with CMD

    select
       when SP = 1 & CMD = '48'X  then do          /* UP ARROW */
          SP = 0; NR = NR - 1
          if NR < 1 | NR < FST then NR = FST + NX * NY - 1
          if NR > FCOUNT then NR = FCOUNT
          call DISPFILE 'X'
          call DISPINFO 'X'
       end  /* Do */

       when SP = 1 & CMD = '50'X then call DOWNARROW     /* DOWN ARROW */

       when SP = 1 & CMD = '4D'X then do           /* RIGHT ARROW */
          NR = NR + NX; if NR >= FST + NX * NY then NR = NR - NX * NY
          if NR > FCOUNT then NR = (NR - 1) // NX + FST
          call DISPFILE 'X'; call DISPINFO 'X'; SP = 0
       end  /* Do */

       when SP = 1 & CMD = '4B'X then do           /* LEFT ARROW */
          NR = NR - NX; if NR < FST then NR = NR + NX * NY
          if NR > FCOUNT then NR = NR - ((NR - FCOUNT - 1) % NX + 1) * NX
          call DISPFILE 'X'; call DISPINFO 'X'; SP = 0
       end  /* Do */

       when SP = 1 & CMD = '51'X then do           /* DOWN */
          FST = FST + NX * NY; if FST > FCOUNT then FST = FST - NX * NY
          NR = FST; SP = 0
          call DISPFILE; call DISPINFO
       end  /* Do */

       when SP = 1 & CMD = '49'X then do           /* UP */
          FST = FST - NX * NY; if FST < 1 then FST = 1
          SP = 0; NR = FST
          call DISPFILE; call DISPINFO
       end  /* Do */

       when (SP = 2 & CMD = '3B'X) | (SP = 0 & CMD = '?') then do  /* Help */
          call SETHELP 'MAIN'; call DISPHELP
          call DISPFILE
          SP = 0
       end  /* Do */

       when(SP = 0 & (CMD = '1B'X | CMD = 'Q'))|(SP=2&CMD='K'/*Alt+F4*/)then do    /* QUIT */
         call M_QUIT; QUITRC = result
         if QUITRC = 'Q' | QUITRC = 'Y' then leave
         call DISPFILE
       end

       when SP = 0 & CMD = 'L' then do            /* LOG DRIVE */
          call M_LOGDRIVE
          if result = '0D'X then do   /* CR was pressed */
             call GETDISP 'NOSORT'
          end
          else do                  /* ESC key was pressed */
             call DISPFRAME
             call DISPFILE
             call DISPINFO
          end  /* Do */
       end

       when SP = 0 & (CMD = '08'X | CMD = '\') then do   /* BS : CD ..*/
          if substr(CURRENT,2) <> ':\' then do           /* \  : CD \ */
            if CMD = '\' then                    /* Altair's special */
               CURRENT = directory('\')          /* Altair's special */
            else
               CURRENT = directory('..')
            CURRENT = directory()
            if right(CURRENT,2) <> ':\' then CURRENT = CURRENT||'\'
            call GETDISP 'NOSORT'
          end
       end  /* Do */

       when SP = 0 & CMD = 'H' then do          /* COMMAND */
          push
          call CMDEXEC; KEY = result; parse pull XCMD; XCMD = strip(XCMD)
          if KEY <> '1B'X then do
            XX = charout(,'1b'x||'[0m'); call CLS   /* Clear attribute */
            call syscurstate 'ON'
            if strip(XCMD) <> '' then do
               call DOCMD ,'@CMD /C' XCMD
            end
            else do
               say; say 'Enter "EXIT" to return'
               '@CMD'
            end  /* Do */
            call GETDISP
          end
          else do
            call DISPFILE
          end
       end  /* Do */

       when SP = 0 & CMD = 'K' then do       /* Make DIR */
           push '[MKDIR] Enter directory name:'; push ''
           call MSGANDGET 2
           parse pull RES
           if result <> '1B'X then do
             call CLS
             call DOCMD 'x','MD' FILENAME(RES)
             call GETDISP
           end
           else do
              call DISPFILE
           end  /* Do */
       end  /* Do */

       when SP = 0 & CMD = 'S' then call M_SORT     /* Sort */

       when SP = 0 & CMD = 'T' then call M_TREE     /* Tree */

       when FCOUNT = 0 then do                      /* No files */
          SP = 0; iterate
       end  /* Do */

       /* If no files, dose not reach bellow. */

       when SP = 0 & (CMD >= 1 & CMD <= 3 | CMD = 5) then do  /* DISPMODE */
          if CMD = 1 then do
             select
                when DISPMODE = '1'  then CMD = '1A'
                when DISPMODE = '1A' then CMD = '1B'
                when DISPMODE = '1B' then CMD = '1C'
                when DISPMODE = '1C' then CMD = '1'
             otherwise
                CMD = DISPMODE1SAV
             end  /* select */
          end  /* Do */
          if DISPMODE <> CMD then do
             call SETDISPM CMD
             call DISPFILE; call DISPINFO 'X'
          end
       end  /* Do */

       when SP = 0 & CMD = ' ' then do              /* SPACE : mark */
          if substr(ATTR.INR,2,1) <> 'D' then do
             if MASK.INR = ' ' then do
                MASK.INR = '*'; MCOUNT = MCOUNT + 1
                MBYTES = MBYTES + BYTES.INR
             end  /* Do */
             else do
                MASK.INR = ' '; MCOUNT = MCOUNT - 1
                MBYTES = MBYTES - BYTES.INR
             end  /* Do */
          end  /* Do */
          call DOWNARROW
       end  /* Do */

       when SP = 1 & CMD = '47'X then do            /* HOME */
          SP = 0
          if MCOUNT = 0 then do
             MCOUNT = 0; MBYTES = 0    /* mark all */
             do I = 1 to FCOUNT
               if substr(ATTR.I,2,1) <> 'D' then do
                 MASK.I = '*'; MCOUNT = MCOUNT + 1
                 MBYTES = MBYTES + BYTES.I
               end  /* Do */
             end /* do */
          end
          else do
             MCOUNT = 0; MBYTES = 0   /* unmark all */
             do I = 1 to FCOUNT
                MASK.I = ' '
             end /* do */
          end  /* Do */
          call DISPFILE; call DISPINFO
       end  /* Do */

       when SP = 1 & CMD = '4F'X then do   /* END:mark invert */
          SP = 0
          MCOUNT = 0; MBYTES = 0
          do I = 1 to FCOUNT
             if substr(ATTR.I,2,1) <> 'D' then do
                if MASK.I = ' ' then do
                  MASK.I = '*'; MCOUNT = MCOUNT + 1
                  MBYTES = MBYTES + BYTES.I
                end
                else do
                  MASK.I = ' '
                end  /* Do */
             end  /* Do */
          end /* do */
          call DISPFILE; call DISPINFO
       end  /* Do */

       when SP = 0 & CMD = 'R' then do            /* Rename */
          push 'Rename'; push FNAME.INR
          call MSGANDGET 2; parse pull NEWNAME; KEY = result
          if KEY <> '1B'X then do
             call CLS
             call DOCMD 'x','RENAME' FILENAME(FNAME.INR) FILENAME(NEWNAME)
             call GETDISP ,'X'
             NR = FPLIST.CURRENT.0; FST = FPLIST.CURRENT.1
          end  /* Do */
          call DISPFILE; call DISPINFO
       end

       when SP = 0 & ((CMD = '0A'X & EXTT = 1) | CMD = 'X') then do
          push FILENAME(FNAME.INR)                                  /* Execute */
          call CMDEXEC; KEY = result; parse pull XCMD; XCMD = strip(XCMD)
          if left(XCMD,1) = '"' then XCMD = '"'XCMD'"'
          if KEY <> '1B'X then do
            call syscurstate 'ON'
            XX = charout(,'1B'X||'[0m'); call CLS
            call DOCMD ,'@CMD /C' XCMD
            call GETDISP
          end
          else call DISPFILE
       end  /* Do */

       when SP = 0 & ((CMD = '0A'X & EXTT = 0) | CMD = 'E') then do
          call RUNMSG
          RC = EXECUTE(FILENAME(FNAME.INR), ,EDITOR)
          if RC <> 0 then do
             say 'Error !    RC =' RC
             XX = charout(,'Press enter key to return'); pull XX
          end  /* Do */
          call CLS
          call DISPFRAME
          call DISPFILE
          call DISPINFO
       end

       when SP = 0 & CMD = 'V' then call BROWSE FNAME.INR   /* View */
       when SP = 0 & CMD = 'P' then call M_PACK            /* Pack */
       when SP = 0 & CMD = 'U' then call M_UNPACK          /* Unpack */
       when SP = 0 & CMD = 'C' then call M_COPY     /* Copy */
       when SP = 0 & CMD = 'M' then call M_MOVE     /* Move */
       when SP = 0 & CMD = 'D' then call M_DEL      /* Del */
       when SP = 0 & CMD = 'F' then call M_FIND     /* FIND */
       when SP = 0 & CMD = '*' then call M_FINDMARK /* FIND & MARK */
       when SP = 0 & CMD = 'A' then call M_ATTRIB   /* ATTRIB */
       when SP = 0 & CMD = 'I' then call M_FINFO    /* File Info */
       when SP = 0 & CMD = '0D'X then call M_CR     /* CR */
       when (SP = 2 & CMD = '44'x) | (SP = 0 & CMD = '$') then call M_SETUP
       when SP = 2 & CMD = '85'x then call M_EAWRT
       when SP = 2 then call M_ALTCODE              /* ALT code process */

       otherwise do
         call DEBUGSAY ,'Undefined key SP=' SP ' CMD=' c2x(CMD)  /* Undefined key */
         SP = 0
       end
    end  /* select */
  end /* do */
/* End of main loop */

/* Ending code */
call GOTOXY ROW 1; X = charout(,'1b'x||'[0m')
if QUITRC = 'Y' then X = directory(ORIGINAL) /* restore original directory */
call syscurstate 'ON'
'@prompt' ORGPROMPT       /* restore original prompt */
call DEBUGSAY ,'$$FD2DEBUGEND$$'
exit

NOTREADY:
  SIGLSAV = SIGL
  call DEBUGSAY ,'Not ready tarp on' SIGLSAV
  call DEBUGSAY ,sourceline(SIGLSAV)
return

HALT:
  SIGLSAV = SIGL
  call DEBUGSAY ,'Halt tarp on' SIGLSAV
  call DEBUGSAY ,sourceline(SIGLSAV)
signal COLD_START

ERROREXIT:                                       /* error trap */
  SIGLSAV = SIGL
  if symbol('RC') = 'VAR' then RCSAV = RC
  else RCSAV = 0
  signal off ERROR
  signal off FAILURE
  signal off HALT
  signal off SYNTAX
  call GOTOXY ROW 1; X = charout(,'1b'x||'[0m')
  call syscurstate 'ON'
  call DEBUGSAY 'x','Condition:' condition('C')
  call DEBUGSAY 'x','Description:' condition('D')
  call DEBUGSAY 'x','Error RC:' RCSAV 'SIGL=' SIGLSAV
  call DEBUGSAY 'x',sourceline(SIGLSAV)
  call DEBUGSAY 'x',errortext(RCSAV)
  call DEBUGSAY 'x','$$FD2DEBUGEND$$'
  trace ?R; nop
exit
/****************************/
/*       Subroutines        */
/****************************/

SAYRC:
  call GOTOXY 1 3; XX = charout(,'RC='RC)
return

M_QUIT: procedure expose ROW COL CCLR. CUL CH CUR CLL CLR CV DEBUGQ DEBUG
  X = ((ROW - 6) % 2) + 5; Y = (COL - 13) % 2
  C1 = CCLR.12; C2 = CCLR.10; C3 = CCLR.10; SP = 0
  do forever
    call GOTOXY X-3 Y
    XX = charout(,CCLR.10||CUL||copies(CH,11)||CUR||CCLR.0||' ')
    call GOTOXY X-2 Y
    XX = charout(,CCLR.10||CV||'           '||CV||CCLR.9||' ')
    call GOTOXY X-1 Y
    XX = charout(,CCLR.10||CV C1 'Y:Yes  ' CCLR.10 CV||CCLR.9||' ')
    call GOTOXY X   Y
    XX = charout(,CCLR.10||CV C2 'N:No   ' CCLR.10 CV||CCLR.9||' ')
    call GOTOXY X+1 Y
    XX = charout(,CCLR.10||CV C3 'Q:Quit ' CCLR.10 CV||CCLR.9||' ')
    call GOTOXY X+2 Y
    XX = charout(,CCLR.10||CV||'           '||CV||CCLR.9||' ')
    call GOTOXY X+3 Y
    XX = charout(,CCLR.10||CLL||copies(CH,11)||CLR||CCLR.9||' ')
    call GOTOXY X+4 Y; XX = charout(,CCLR.0 CCLR.9||'             ')
    parse upper value sysgetkey('NOECHO') with KK
    select
      when KK = 'E0'X then SP = 1
      when SP = 0 & (KK = 'Y' | KK = 'Q' | KK = 'N')  then leave
      when KK = '00'X then XX = sysgetkey('NOECHO')  /* discard */
      when SP = 1 & (KK = '48'X | KK = '4B'X) then do    /* UP */
         SP = 0; TEMP = C1; C1 = C2; C2 = C3; C3 = TEMP
      end  /* Do */
      when SP = 1 & (KK = '50'X | KK = '4D'X) then do    /* DOWN */
         SP = 0; TEMP = C3; C3 = C2; C2 = C1; C1 = TEMP
      end  /* Do */
      when SP = 0 & KK = '0D'X then do   /* Enter */
         select
            when C1 = C2 then KK = 'Q'
            when C1 = C3 then KK = 'N'
            when C2 = C3 then KK = 'Y'
            otherwise nop
         end  /* select */
         leave
      end  /* Do */
      when SP = 0 & KK = '1B'X then do   /* Esc */
         KK = 'N'; leave
      end  /* Do */
      otherwise SP = 0
   end
  end
return KK

M_LOGDRIVE: procedure expose CURRENT ROW COL CUR CUL CV CH CLL CLR CCLR. ,
                             FD2DLL DEBUGQ DEBUG
  DMAP = 'A: B:' SysDriveMap()
  call DEBUGSAY ,DMAP
  LDMAP = SysDriveMap(,'LOCAL')
/* DMAP = 'A: B: C: D: E: F: G: H: I: J: K: L: M: N: O: P: Q: R: S: T: U: V: W: X: Y: Z:' */
  call DEBUGSAY ,'L' LDMAP
  QDMAP = words(DMAP)
  if  FD2DLL = 0 then do
     do I = 3 to QDMAP
        DMAP.I = c2d(bitand(substr(RXGETDEVPARM(left(word(DMAP,I),1)),35,1),'01'x))
        if wordpos(word(DMAP,I),LDMAP) = 0 then DMAP.I = DMAP.I + 2
        call DEBUGSAY , DMAP.I
     end /* do */
  end  /* Do */
  D = left(CURRENT,1)
  LL = words(DMAP) * 3
  X = ((ROW - 6) % 2) + 7
  Y = (COL - LL) % 2
  call GOTOXY X-6 Y
  XX = charout(,CCLR.10||CUL||copies(CH,LL-1)||CUR||CCLR.0)
  call GOTOXY X-5 Y
  XX = charout(,CCLR.10||CV)
  do I = 1 to QDMAP
     select
        when DMAP.I = 1 then XX = charout(,CCLR.21||word(DMAP,I))
        when DMAP.I = 2 then XX = charout(,CCLR.22||word(DMAP,I))
        when DMAP.I = 3 then XX = charout(,CCLR.23||word(DMAP,I))
     otherwise
        XX = charout(,CCLR.20||word(DMAP,I))
     end  /* select */
     if I < QDMAP then XX = charout(,CCLR.19' ')
  end /* do */
  XX = charout(,CCLR.10||CV||CCLR.0)
  call GOTOXY X-4 Y
  XX = charout(,CCLR.10||CLL||copies(CH,LL-1)||CLR||CCLR.0)

  Y = (COL - 13) % 2
  call GOTOXY X-2 Y
  XX = charout(,CCLR.10||CUL||copies(CH,12)||CUR||CCLR.0||' ')
  call GOTOXY X-1 Y
  XX = charout(,CCLR.10||CV||'            '||CV||CCLR.9||' ')
  call GOTOXY X Y
  XX = charout(,CCLR.10||CV||' Drive: '||CCLR.11||' 'D' '||,
                CCLR.10||' '||CV||CCLR.9||' ')
  call GOTOXY X+1 Y
  XX = charout(,CCLR.10||CV||'            '||CV||CCLR.9||' ')
  call GOTOXY X+2 Y
  XX = charout(,CCLR.10||CLL||copies(CH,12)||CLR||CCLR.9||' ')
  call GOTOXY X+3 Y; XX = charout(,CCLR.0 CCLR.9||'              ')
  do until KEY = '0D'X | KEY = '1B'X
    call GOTOXY X Y+9; Z = charout(,CCLR.11)
    parse upper value sysgetkey('NOECHO') with KEY
    select
       when KEY = 'E0'X then SP = 1      /* Extended key code */
       when KEY = '00'X then SP = 2      /* alt key code */
       otherwise SP = 0
    end
    if SP <> 0 then parse upper value sysgetkey('NOECHO') with KEY
    P = wordpos(D':',DMAP)
    select
       when SP = 1 & KEY = '48'x then do
          P = P + 1
          if P > QDMAP then P = 1
          KEY = left(word(DMAP,P),1)
          SP = 0
       end  /* Do */
       when SP = 1 & KEY = '50'x then do
          P = P - 1
          if P < 1 then P = QDMAP
          KEY = left(word(DMAP,P),1)
          SP = 0
       end  /* Do */
    otherwise nop
    end  /* select */
    if SP = 0 & ('A' <= KEY & KEY <= 'Z') then do
       D = KEY
       Z = charout(,center(D,3))
    end  /* Do */
  end /* do */
  if SP = 0 & KEY = '0D'X then do   /* CR was pressed */
     parse value SysDriveInfo(D||':') with DD .  /* checking drive avilability */
     if DD = '' then do
        call RUNMSG 'Drive' D 'is not available.'
        call SysSleep 1
        KEY = '1B'x
     end
     else do
        CURRENT = directory(DD)
        if right(CURRENT,2) <> ':\' then CURRENT = CURRENT||'\'
     end
  end
return KEY

M_PACK:
  if MCOUNT = 0 then
    push '[PACK CURRENT FILE] Enter archive name:'
  else
    push '[PACK MARKED FILE] Enter archive name:'
  push ''
  call MSGANDGET 2
  parse pull RES; RES = strip(RES)
  if result <> '1B'X then do
     call CLS
     if MCOUNT = 0 then do
        RC = EXECUTE(FILENAME(FNAME.INR), FILENAME(RES), APACK)
        if RC <> 0 then do
           say 'Error !    RC =' RC
           XX = charout(,'Press enter key to return'); pull XX
        end  /* Do */
        call GETDISP
     end
     else do
       FILES = ''
       do I = 1 to FCOUNT
         II = FIDX.I
         if MASK.II = '*' then FILES = FILES FILENAME(FNAME.II)
         if words(FILES) > 4 then do
           RC = EXECUTE(FILES, FILENAME(RES), APACK)
           if RC <> 0 then do
              say 'Error !    RC =' RC
              XX = charout(,"Enter 'Q' to quit, any other key to continue:")
              pull XX
              if XX = 'Q' | XX = 'QUIT' then leave
           end  /* Do */
           FILES = ''
         end  /* Do */
       end /* do */
       if FILES <> '' then RC = EXECUTE(FILES, FILENAME(RES), APACK)
       call GETDISP
     end  /* Do */
  end
  else do
     call DISPFILE; call DISPINFO
  end
return

M_UNPACK:
  if pos(EXT,AUNPK) <> 0 then do
    parse upper value GETAUNPK(EXT) with X
    if pos('%D',X) = 0 then do
       RES = ''; result = 99
    end  /* Do */
    else do
      push '[UNPACK] Enter destination: (TREE: Ctrl+Enter)'; push ''
      call MSGANDGET 2
      parse pull RES; RES = strip(RES)
      if result = '0A'x then do
         call TREEMODE RES
         RES = NEWDIR
      end  /* Do */
      if RES = '' then RES = CURRENT
    end
    if result <> '1B'X then do
      call CLS
      RC = EXECUTE(FILENAME(FNAME.INR), FILENAME(RES), GETAUNPK(EXT))
      if RC <> 0 then do
         say 'Error !    RC =' RC
         XX = charout(,'Press enter key to return'); pull XX
      end  /* Do */
      call GETDISP
    end
    else do
       call DISPFILE
    end  /* Do */
  end  /* Do */
return

M_COPY:
  if MCOUNT = 0 then                   /* marked ? */
    push '[COPY-CURRENT] Enter distination: (TREE: Ctrl+Enter)'
  else
    push '[COPY-MARKED] Enter distination: (TREE: Ctrl+Enter)'
  push ''
  call MSGANDGET 2
  parse pull RES; RES = strip(RES)
  if (result <> '1B'X & RES = '') | result = '0A'x then do
     call TREEMODE RES
     RES = NEWDIR
  end  /* Do */
  if result <> '1B'X then do          /* Canceled ? */
     call CLS
     if MCOUNT = 0 then do            /* Current file */
        call DOCMD 'x','COPY' FILENAME(FNAME.INR) FILENAME(RES)
        call GETDISP
     end
     else do                          /* Marked files */
        do I = 1 to FCOUNT
           II = FIDX.I
           if MASK.II = '*' then do
              'COPY' FILENAME(FNAME.II) FILENAME(RES)
              if RC <> 0 then do
                 call DEBUGSAY 'x','Copy error !  RC='RC FILENAME(FNAME.II) FILENAME(RES)
                 XX=charout(,"Enter 'Q' to quit, any other key to conyinue:")
                 pull XX
                 if XX = 'Q' | XX = 'QUIT' then leave
              end  /* Do */
           end  /* Do */
        end /* do */
        call GETDISP
     end  /* Do */
  end
  else do
    call DISPFILE; call DISPINFO
  end
return

M_MOVE:
  if MCOUNT = 0 then                          /* Marked ? */
    push '[MOVE-CURRENT] Enter destination path: (TREE: Ctrl+Enter)'
  else
    push '[MOVE-MARKED] Enter destination path: (TREE: Ctrl+Enter)'
  push ''
  call MSGANDGET 2
  pull RES; RES = strip(RES)
  if (result <> '1B'X & RES = '') | result = '0A'x then do
     call TREEMODE RES
     RES = NEWDIR
  end  /* Do */
  if result<>'1B'X then do
     if substr(RES,2,1)=':' & left(CURRENT,2)<>left(RES,2) then call MOVE2
     else call MOVE1
  end
  else do
     call DISPFILE; call DISPINFO
  end
return

MOVE1:                          /* Move files */
   call CLS
   if substr(RES,2,1) = ':' then RES = substr(RES,3)        /* Remove drv */
   if right(RES,1) = '\' then RES = left(RES,length(RES)-1) /* RMV right\ */
   if length(RES) = 0 then do
      RES = '\'                        /* Root */
      XRC = QUERYFILE('\'FILENAME(FNAME.INR))
      YRC = 1
   end
   else do
      XRC = QUERYFILE(RES'\'FILENAME(FNAME.INR))
      YRC = QUERYFILE(RES)
   end  /* Do */
   if MCOUNT = 0 then do              /* Current file */
      if XRC = 2 & YRC = 1 then call DOCMD ,'MOVE' FILENAME(FNAME.INR) FILENAME(RES)
      else do
         say 'Destination is not existing directory or file name exists.'
         XX = charout(,'Press enter key to return'); pull XX
      end  /* Do */
   end
   else do                            /* Marked files */
     if YRC <> 1 then do
         say 'Destination is not a directory.'
      end  /* Do */
      else do
         do I = 1 to FCOUNT
            II = FIDX.I
            if MASK.II = '*' then do
               'MOVE' FILENAME(FNAME.II) FILENAME(RES)
               if RC <> 0 then do
                  call DEBUGSAY 'X','MOVE Error !  RC='RC FILENAME(FNAME.II) FILENAME(RES)
                  XX=charout(,"Enter 'Q' to quit, any other key to continue:")
                  pull XX
                  if XX = 'Q' | XX = 'QUIT' then leave
               end  /* Do */
            end  /* Do */
         end /* do */
      end
      XX=charout(,"Press enter key to return")
      pull XX
   end  /* Do */
   call GETDISP
return

MOVE2:                                     /* Copy & delete */
   call CLS
   if MCOUNT = 0 then do              /* Current file */
      'COPY' FILENAME(FNAME.INR) FILENAME(RES)
      if RC <> 0 then do
         call DEBUGSAY 'x','COPY Error !  RC='RC FILENAME(FNAME.INR) FILENAME(RES)
         XX = charout(,'Press enter key to return'); pull XX
      end  /* Do */
      else do
         call DISPFRAME; call DISPFILE; call DISPINFO
         push 'Delete original file ?'
         call MSGANDYN
         if result <> '1B'x then do
            call CLS
            call DOCMD 'x','DEL' FILENAME(FNAME.INR)
         end  /* Do */
      end  /* Do */
      call GETDISP
   end
   else do                            /* Marked files */
     COPIED. = ''
     do I = 1 to FCOUNT
        II = FIDX.I
        if MASK.II = '*' then do
           'COPY' FILENAME(FNAME.II) FILENAME(RES)
           if RC <> 0 then do
              call DEBUGSAY 'x','COPY Error !  RC='RC FILENAME(FNAME.II) FILENAME(RES)
              XX = charout(,"Enter 'Q' to quit, any other key to continue:")
              pull XX
              if XX = 'Q' | XX = 'QUIT' then leave
              COPIED.II = ''
           end  /* Do */
           else COPIED.II = '*'
        end  /* Do */
     end /* do */
     call DISPFRAME; call DISPFILE; call DISPINFO
     push 'Delete original file ?'
     call MSGANDYN
     if result <> '1B'x then do
        call CLS
        do I = 1 to FCOUNT
           II = FIDX.I
           if COPIED.II = '*' then do
              'DEL' FILENAME(FNAME.II)
              if RC <> 0 then do
                call DEBUGSAY 'x','DEL Error !  RC='RC FILENAME(FNAME.II)
                XX=charout(,"Enter 'Q' to quit, any other key to continue:")
                pull XX
                if XX = 'Q' | XX = 'QUIT' then leave
              end  /* Do */
           end  /* Do */
        end /* do */
     end  /* Do */
     call GETDISP
   end  /* Do */
return

M_DEL:
  if MCOUNT = 0 then do          /* Marked ? */
    if substr(ATTR.INR,2,1) = 'D' then do
      push '[DEL - DIRECTORY]'
      call MSGANDYN
      if result <> '1B'X then do
         call DELDIR ATTR.INR FNAME.INR
         if result = 0 then call GETDISP
         else do
            call CLS; call DISPFRAME; call DISPFILE; call DISPINFO
         end  /* Do */
      end  /* Do */
      else do
         call DISPFILE
      end  /* Do */
    end  /* Do */
    else do
      push '[DEL - CURRENT]'
      call MSGANDYN
      if result <> '1B'X then do   /* Canceled ? */
        call CLS
        call DOCMD 'X','DEL' FILENAME(FNAME.INR)
        call GETDISP
      end
      else do
        call DISPFILE
      end
    end  /* Do */
  end  /* Do */
  else do
    push '[DEL - MARKED FILE]'
    call MSGANDYN 2
    if result <> '1B'X then do   /* Canceled ? */
      call CLS
      do I = 1 to FCOUNT
        II = FIDX.I
        if MASK.II = '*' then do
           'DEL' FILENAME(FNAME.II)
           if RC <> 0 then do
              call DEBUGSAY 'x','DEL Error !  RC='RC FILENAME(FNAME.II)
              XX=charout(,"Enter 'Q' to quit, any other key to continue:")
              pull XX
              if XX = 'Q' | XX = 'QUIT' then leave
           end  /* Do */
        end  /* Do */
      end /* do */
      call GETDISP
    end
    else do
      call CLS; call DISPFRAME; call DISPFILE; call DISPINFO
    end
  end  /* Do */
return

DELDIR: procedure expose CURRENT ROW DEBUGQ DEBUG
  arg AT DIR                              /* Co-routine for M_DEL */
  if substr(AT,3) <> '---' then SRHFLAG = 1
  else SRHFLAG = 0
  call CLS; XX=charout(,'Reading the directory structure.'||'0D'X||'0A'X)
  call sysfiletree CURRENT||DIR||'\', 'DELBUFF', 'SBT'
  do I = 1 to DELBUFF.0
     if substr(word(DELBUFF.I,3),3) <> '---' then do
        SRHFLAG = 1
        say '  ' subword(DELBUFF.I,3)
     end  /* Do */
  end /* do */
  if SRHFLAG = 1 then do
     say 'Found SYSTEM, READ ONLY or HIDDEN file[s].'
     say 'Delete directory operation is canceled.'
     say 'Press ENTER to return FD/2 screen.'
     pull .
  end
  else do
     do I = DELBUFF.0 to 1 by -1
        if word(DELBUFF.I,3) = '-D---' then do
           'RD' FILENAME(subword(DELBUFF.I,4))
           if RC <> 0 then do
              call DEBUGSAY 'x','RD Error !  RC='RC FILENAME(subword(DELBUFF.I,4))
              call DEBUGSAY 'x','Delete directory is canceled.'
              say 'Press ENTER to return FD/2 screen.'
              pull .
              return 0
           end  /* Do */
        end  /* Do */
        else do
           'DEL' FILENAME(subword(DELBUFF.I,4))
           if RC <> 0 then do
              call DEBUGSAY 'x','DEL Error !  RC='RC FILENAME(subword(DELBUFF.I,4))
              call DEBUGSAY 'x','Delete directory is canceled.'
              say 'Press ENTER to return FD/2 screen.'
              pull .
              return 0
           end  /* Do */
        end  /* Do */
     end /* do */
     'RD' FILENAME(CURRENT||DIR)
     if RC <> 0 then do
        call DEBUGSAY 'x','RD Error !  RC='RC FILENAME(CURRENT||DIR)
        call DEBUGSAY 'x','Delete directory is canceled.'
        say 'Press ENTER to return FD/2 screen.'
        pull .
     end  /* Do */
  end  /* Do */
return SRHFLAG

M_TREE:
   call TREEMODE
   if result <> '1B'X then do
      LEN = length(NEWDIR)-1; if LEN < 3 then LEN = 3
      CURRENT = directory(left(NEWDIR,LEN))
      if right(CURRENT,2) <> ':\' then CURRENT = CURRENT||'\'
      call GETDISP 'NOSORT'
   end  /* Do */
   else do
      call DISPFILE; call DISPINFO
   end
return

M_CR:
  if substr(ATTR.INR,2,1) = 'D' then do             /* DIRECTORY */
    CURRENT = directory(FNAME.INR)||'\'
    call GETDISP 'NOSORT'
  end
  else do
    if wordpos(EXT,ALIST) <> 0 then do                 /* Archiver list */
       call CLS
       RC = EXECUTE(FILENAME(FNAME.INR), , GETALIST(EXT))
       XX = charout(,'Press enter key to return'); pull XX
       call CLS; call DISPFRAME; call DISPFILE; call DISPINFO
    end  /* Do */
    else call BROWSE FNAME.INR
  end
return

M_FINDMARK: procedure expose MCOUNT MBYTES MASK. ATTR. CCLR. BYTES. CURRENT,
                             TYPE. FILE. FBYTES FCOUNT NR FNAME. TOTAL,
                             FREE VOLID FST ROW COL LFILE DISPMODE LL LBL,
                             FLM NX NY LNR LFL CUL CUR CV CH CLL CLR FIDX. ,
                             LNAME. ROW DEBUGQ DEBUG
   push '[FIND & MARK] Enter file mask:'; push ''
   call MSGANDGET 2
   pull RES; FN = strip(RES)
   if result <> '1B'X & FN <> '' then do
      MCOUNT = 0; MBYTES = 0
      do I = 1 to FCOUNT
         II = FIDX.I
         MASK.II = ' '
         if substr(ATTR.II,2,1) <> 'D' then do
            push FN; push FNAME.II
            if STRCMPX() = 0 then do
               MASK.II = '*'; MCOUNT = MCOUNT + 1
               MBYTES = MBYTES + BYTES.II
            end
         end  /* Do */
      end /* do */
   end
   call DISPFILE; call DISPINFO
return

M_FIND: procedure expose FST ROW COL FILE. LFILE TYPE. DISPMODE ATTR. LL,
                         INR LBL FLM CCLR. NX NY NR LNR FNAME. MASK. LFL,
                         FCOUNT CCLR. CURRENT  FBYTES MBYTES MCOUNT NR,
                         TOTAL FREE VOLID BYTES. CUL CH CUR CV CLL CLR FIDX.,
                         LNAME. CDROM. DEBUGQ DEBUG
   push '[FIND] Enter file mask:'; push ''
   call MSGANDGET 2
   pull RES; FN = strip(RES)
   if result <> '1B'X & FN <> '' then do
      TRK = 0; FBYTES = 0; MBYTES = 0; FST = 1; NR = 0; MCOUNT = 0
      do I = 1 to FCOUNT
         II = FIDX.I
         push FN; push FNAME.II
         if STRCMPX() = 0 then do
            TRK = TRK + 1
            XFNAME.TRK = FNAME.II; XATTR.TRK = ATTR.II
            XMASK.TRK = MASK.II; XFILE.TRK = FILE.II
            XTYPE.TRK = TYPE.II; XBYTES.TRK = BYTES.II
            XLNAME.TRK = LNAME.II
            FBYTES = FBYTES + XBYTES.TRK
            if symbol('CDROM.II') = 'VAR' then XCDROM.TRK = CDROM.II
            if XMASK.TRK = '*' then do
               MBYTES = MBYTES + XBYTES.TRK; MCOUNT = MCOUNT + 1
            end  /* Do */
         end  /* Do */
      end /* do */
      do I = TRK+1 to FCOUNT
         FIDX.I = ''
      end /* do */
      FILE.0 = TRK; FCOUNT = TRK; FIDX.0 = TRK
      do I = 1 to TRK
         FIDX.I = I
         FNAME.I = XFNAME.I; ATTR.I = XATTR.I
         MASK.I = XMASK.I; FILE.I = XFILE.I
         TYPE.I = XTYPE.I; BYTES.I = XBYTES.I
         LNAME.I = XLNAME.I
         if symbol('XCDROM.I') = 'VAR' then CDROM.I = XCDROM.I
         else drop CDROM.I
      end /* do */
   end  /* Do */
   call DISPFILE; call DISPINFO
return

M_SORT:
  MSGSEL.0 = '6 10'
  MSGSEL.1 = '[SORT KEY]'
  MSGSEL.2 = ' N:Name'
  MSGSEL.3 = ' T:Type'
  MSGSEL.4 = ' D:Date'
  MSGSEL.5 = ' S:Size'
  MSGSEL.6 = ' O:nOne'
  call MSGANDSEL
  if result <> 0 then do
    parse upper value MSGSEL.result with . ':' FSORTKEY
    call DISPFILE
    MSGSEL.0 = '3 12'
    MSGSEL.1 = '[SORT ORDER]'
    MSGSEL.2 = ' N:Normal'
    MSGSEL.3 = ' R:Reverse'
    call MSGANDSEL
    if result <> 0 then do
       FSORTORD = substr(MSGSEL.result,2,1)
       call DISPFILE
       call RUNMSG
       call FSORT
    end  /* Do */
  end  /* Do */
  call DISPFILE; call DISPINFO
return

M_ATTRIB:
/*if ATTR.INR <> '-D---' then do
     if left(ATTR.INR,1)     = 'A' then XATTR.2 = 'ON'
     else XATTR.2 = 'OFF'*/
     do I=1 to 5
        YATTR.I=substr(ATTR.INR,I,1)<>'-'
        if YATTR.I then XATTR.I='ON'; else XATTR.I = 'OFF'
     end /* do */
     push XATTR.1 YATTR.1 YATTR.2
     pull XATTR.2 YATTR.2 YATTR.1
     if YATTR.1 then do I=2 to 4 by 2
       if\YATTR.I then XATTR.I='---'
     end

     MSGSEL.0 = 6 14
     MSGSEL.1 = '['FNAME.INR']'
     SEL = 2
     do forever
        MSGSEL.2 = 'A:ARCHIVE ' XATTR.2
        MSGSEL.3 = 'H:HIDDEN  ' XATTR.3
        MSGSEL.4 = 'R:READONLY' XATTR.4
        MSGSEL.5 = 'S:SYSTEM  ' XATTR.5
        MSGSEL.6 = 'W: < WRITE >'
        call MSGANDSEL SEL
        if result = 0 | result = 6 then leave/*do forever*/
        do 1
          if YATTR.1/*D*/then
            if result=2/*A*/|result=4/*R*/then
              if\YATTR.result then leave/*do 1*/
          if XATTR.result = 'ON' then XATTR.result = 'OFF'
          else XATTR.result = 'ON'
        end
        SEL = result
     end /* do */
     if result = 6 then do
        ATOPT = ''                /* build attrib option */
        if XATTR.2 = 'ON' then ATOPT = ATOPT '+A'
        else ATOPT = ATOPT '-A'
        if XATTR.3 = 'ON' then ATOPT = ATOPT '+H'
        else ATOPT = ATOPT '-H'
        if XATTR.4 = 'ON' then ATOPT = ATOPT '+R'
        else ATOPT = ATOPT '-R'
        if XATTR.5 = 'ON' then ATOPT = ATOPT '+S'
        else ATOPT = ATOPT '-S'
        call CLS
        call DOCMD 'x','ATTRIB' ATOPT FILENAME(FNAME.INR)
        call GETDISP
     end  /* Do */
     else call DISPFILE
  drop YATTR.
/*end*/
return

M_FINFO:
  ISTEM. = ''
  J = 0
  if symbol('CDROM.INR') = 'VAR' then do
     J = J + 1
     ISTEM.J.0TYPE = 'INDEX FILE'
     ISTEM.J.0DATA.0 = 1
     ISTEM.J.0DATA.1 = CDROM.INR
  end  /* Do */
  do I = 1 to EALIST.0                /* EALIST contains EA types */
     XXEA = ''                   /* for SysGetEA failure */
     X = SysGetEA(FNAME.INR,EALIST.I,'XXEA')  /* Get Ext Attrib */
     if XXEA <> '' then do
        J = J + 1
        ISTEM.J.0TYPE = substr(EALIST.I,2)
        call EAANAL XXEA                      /* EASTEM <- XXEA */
        do K = 0 to EASTEM.0
           ISTEM.J.0DATA.K = EASTEM.K
        end /* do */
     end  /* Do */
  end /* do */

  if J > 0 then do
    ISTEM.0 = J
    XRC = DISPISTEM(FNAME.INR)
    if XRC = '85'x then call M_EAWRT
    call DISPFILE
  end  /* Do */
return

M_ALTCODE:   /* Locate file with 1st charcter */
  X = c2x(CMD)
  X = ALTT.X
  if X <> '' then do
     do I = 1 to FCOUNT
        II = I + NR
        if II > FCOUNT then II = II - FCOUNT
        XNR = FIDX.II
        parse upper value FNAME.XNR with XX 2 .
        if X = XX then leave
     end /* do */
     if I <= FCOUNT then do
        if FST <= II & II < FST + NX * NY then do
           NR = II
           call DISPFILE 'X'
           call DISPINFO 'X'
        end  /* Do */
        else do
           NR = II
           FST = II
           call DISPFILE
           call DISPINFO 'X'
        end  /* Do */
     end  /* Do */
  end  /* Do */
  else call DEBUGSAY ,'Undefined key SP=' SP ' CMD=' c2x(CMD)  /* Undefined key */
  SP = 0
return

M_SETUP:
   SP = 0
   call LOADSETUPSTEM
   S = 0
   do forever
      J = SETUPMAIN(S)
      select
         when J = SETUPSTEM.S.0 then do  /* Save option is selected */
            I = 1
            I=I+1;LONGNAMEMODE = SETUPSTEM.0.I.1
            I=I+1;CDROMINDEX   = SETUPSTEM.0.I.1
            I=I+1;EACOMMENTS   = SETUPSTEM.0.I.1
            I=I+1;PM_EDITOR    = SETUPSTEM.0.I.1
            I=I+1;PM_VIEWER    = SETUPSTEM.0.I.1
            I=I+1;NET_EDITOR   = SETUPSTEM.0.I.1
            I=I+1;NET_VIEWER   = SETUPSTEM.0.I.1
            I=I+1;APACK        = SETUPSTEM.0.I.1
            I=I+1;DISPMODE     = SETUPSTEM.0.I.1
            I=I+1;DISPMODE1SAV = SETUPSTEM.0.I.1
            do I = 2 to 15
               parse value SETUPSTEM.1.I.0 with E '=' C
               if E <> '' then call PUTALIST strip(E),strip(C)
            end /* do */
            do I = 2 to 15
               parse value SETUPSTEM.2.I.0 with E '=' C
               if E <> '' then call PUTAUNPK strip(E),strip(C)
            end /* do */
            call SETDISPM DISPMODE
            if NETMODE = 1 then do
               EDITOR = NET_EDITOR
               VIEWER = NET_VIEWER
            end  /* Do */
            else do
               EDITOR = PM_EDITOR
               VIEWER = PM_VIEWER
            end  /* Do */
            push '[ Write INI File ? ('INIPATH') ]'
            if MSGANDYN() = 'Y' then call WRITEINI
            leave
         end  /* Do */
         when J = SETUPSTEM.S.0 - 2 then do  /* Adavanced or Next Setup */
            S = S + 1
            if S > 2 then S = 0
         end  /* Do */
      otherwise leave
      end  /* select */
   end /* do */
   drop SETUPSTEM.
   call DISPFRAME
   call DISPFILE
   call DISPINFO
return

M_EAWRT:
   RC = EAWRT(FILENAME(CURRENT||FNAME.INR))
   if RC <> 0 then do
      call CLS
      call DISPFRAME
      call DISPFILE
      call DISPINFO
   end /* do */
   if RC = 1041 then do
      call RUNMSG 'Please install EPM !'
      call SysSleep 1
      call DISPFILE
   end /* do */
return

/******************/
/* Other routines */
/******************/

EAWRT: procedure expose ROW DEBUG DEBUGQ
parse arg FN
  NEWQ = RXQUEUE('Create')
  OQ = RXQUEUE('Set',NEWQ)
  X = SysGetEA(FN,'.COMMENTS','XXEA')  /* Get Ext Attrib */
  if XXEA <> '' then do
     call EAANAL XXEA                      /* EASTEM <- XXEA */
     do K = 1 to EASTEM.0
        queue EASTEM.K
     end /* do */
  end  /* Do */
  parse source . . PATH     /* Get path of FD/2 */
  options 'EXMODE'
  IPATH = filespec('Drive',PATH)||filespec('Path',PATH)
  options 'NOEXMODE'
  "@EPM 'RX" IPATH||"FD2EAWRT MENU" NEWQ IPATH FILENAME(FN)"'"
  XRC = RC
  call RXQUEUE 'Set',OQ
return XRC

LOADSETUPSTEM:
   S = 0
   I = 0
   SETUPSTEM. = ''
   I=I+1;SETUPSTEM.S.I.0  = '[ FD/2 SETUP ]'
   I=I+1;SETUPSTEM.S.I.0  = 'LONGNAME Mode (ON/OFF)'
   SETUPSTEM.S.I.1  = LONGNAMEMODE
   I=I+1;SETUPSTEM.S.I.0  = 'CDROM Index (ON/OFF)'
   SETUPSTEM.S.I.1  = CDROMINDEX
   I=I+1;SETUPSTEM.S.I.0  = 'EA Comments (ON/OFF)'
   SETUPSTEM.S.I.1  = EACOMMENTS
   I=I+1;SETUPSTEM.S.I.0  = 'Editor (Normal mode)'
   SETUPSTEM.S.I.1  = PM_EDITOR
   I=I+1;SETUPSTEM.S.I.0  = 'Viewer (Normal mode)'
   SETUPSTEM.S.I.1  = PM_VIEWER
   I=I+1;SETUPSTEM.S.I.0  = 'Netmode Editor'
   SETUPSTEM.S.I.1  = NET_EDITOR
   I=I+1;SETUPSTEM.S.I.0  = 'Netmode Viewer'
   SETUPSTEM.S.I.1  = NET_VIEWER
   I=I+1;SETUPSTEM.S.I.0  = 'Pack Command'
   SETUPSTEM.S.I.1  = APACK
   I=I+1;SETUPSTEM.S.I.0 = 'Display Mode'
   SETUPSTEM.S.I.1 = DISPMODE
   I=I+1;SETUPSTEM.S.I.0 = 'Display Mode 1'
   SETUPSTEM.S.I.1 = DISPMODE1SAV
   I=I+1;SETUPSTEM.S.I.0 = 'N: Next Setup Screen'
   I=I+1;SETUPSTEM.S.I.0 = 'Q: Esc: Quit'
   I=I+1;SETUPSTEM.S.I.0 = 'S: Save'
   SETUPSTEM.S.0 = I
   S = 1
   I = 0
   I=I+1;SETUPSTEM.S.I.0  = '[ Action for Enter Key ] - Archive list'
   do J = 1 to words(ALIST)
      I=I+1;SETUPSTEM.S.I.0 = word(ALIST,J) '=' GETALIST(word(ALIST,J))
   end /* do */
   I = 15
   I=I+1;SETUPSTEM.S.I.0 = 'N: Next Setup Screen'
   I=I+1;SETUPSTEM.S.I.0 = 'Q: Esc: Quit'
   I=I+1;SETUPSTEM.S.I.0 = 'S: Save'
   SETUPSTEM.S.0 = I
   S = 2
   I = 0
   I=I+1;SETUPSTEM.S.I.0  = '[ Action for U command ] - Unpack'
   do J = 1 to words(AUNPK)
      I=I+1;SETUPSTEM.S.I.0 = word(AUNPK,J) '=' GETAUNPK(word(AUNPK,J))
   end /* do */
   I = 15
   I=I+1;SETUPSTEM.S.I.0 = 'N: Next Setup Screen'
   I=I+1;SETUPSTEM.S.I.0 = 'Q: Esc: Quit'
   I=I+1;SETUPSTEM.S.I.0 = 'S: Save'
   SETUPSTEM.S.0    = I
return

SETUPMAIN: procedure expose ROW COL CCLR. CUL CH CUR CLL CLR CV MSGSEL.,
                            SETUPSTEM. DEBUGQ DEBUG DISPMODE1SAV
arg S .
   LEN = 0; LEN2 = 0
   do I = 2 to SETUPSTEM.S.0
      LEN = MAX(LEN,length(SETUPSTEM.S.I.0))
   end /* do */
   do I = 2 to SETUPSTEM.S.0
      if I < SETUPSTEM.S.0 - 2 & S = 0 then do
         MSGSEL.I = left(SETUPSTEM.S.I.0,LEN) '=' SETUPSTEM.S.I.1
         LEN2 = MAX(LEN2,length(MSGSEL.I))
      end  /* Do */
      else do
         MSGSEL.I = SETUPSTEM.S.I.0
         LEN2 = max(LEN2,length(MSGSEL.I))
      end  /* Do */
   end /* do */
   LEN2 = max(LEN2,length(SETUPSTEM.S.1.0))
   MSGSEL.0 = SETUPSTEM.S.0 LEN2
   MSGSEL.1 = center(SETUPSTEM.S.1.0,LEN2)
   do forever
      SEL = MSGANDSEL(SEL)
      if SEL = 0 | SEL > SETUPSTEM.S.0 - 3 then leave
      do forever
         if S = 0 then do
            push SETUPSTEM.S.SEL.0
            push SETUPSTEM.S.SEL.1
         end
         else do
            push 'ext = command template  %a:Archive %d:Directory %f:Filename'
            push SETUPSTEM.S.SEL.0
         end  /* Do */
         KEY = MSGANDGET(0)
         parse pull RES
         if KEY = '48'x | KEY = '50'x then do    /* Up or Down arrow keys */
            if word(SETUPSTEM.S.SEL.0,3) = '(ON/OFF)' then do
               if SETUPSTEM.S.SEL.1 = 'ON' then SETUPSTEM.S.SEL.1 = 'OFF'
               else SETUPSTEM.S.SEL.1 = 'ON'
            end
            else if SETUPSTEM.S.SEL.0 = 'Display Mode' then do
               select
                  when left(SETUPSTEM.S.SEL.1,1) = 1 then SETUPSTEM.S.SEL.1 = 2
                  when SETUPSTEM.S.SEL.1 = 2 then SETUPSTEM.S.SEL.1 = 3
                  when SETUPSTEM.S.SEL.1 = 3 then SETUPSTEM.S.SEL.1 = 5
               otherwise SETUPSTEM.S.SEL.1 = DISPMODE1SAV
               end  /* select */
            end
            else if SETUPSTEM.S.SEL.0 = 'Display Mode 1' then do
               select
                  when SETUPSTEM.S.SEL.1 = '1' then SETUPSTEM.S.SEL.1 = '1A'
                  when SETUPSTEM.S.SEL.1 = '1A' then SETUPSTEM.S.SEL.1 = '1B'
                  when SETUPSTEM.S.SEL.1 = '1B' then SETUPSTEM.S.SEL.1 = '1C'
               otherwise SETUPSTEM.S.SEL.1 = '1'
               end  /* select */
            end  /* Do */
            iterate
         end  /* Do */
         if KEY <> '1B'x then do
            if S = 0 then do
               SETUPSTEM.S.SEL.1 = strip(RES)
               MSGSEL.SEL = left(SETUPSTEM.S.SEL.0,LEN) '=' SETUPSTEM.S.SEL.1
            end  /* Do */
            else do
               SETUPSTEM.S.SEL.0 = strip(RES)
               MSGSEL.SEL = SETUPSTEM.S.SEL.0
            end  /* Do */
         end  /* Do */
         leave
      end /* do */
   end /* do */
   drop MSGSEL.
return SEL

DISPISTEM: procedure expose ISTEM. ROW COL CCLR. CH CUL CUR CLL CLR CV,
                            DEBUGQ DEBUG
parse arg FN
  /* DISPlay ISTEM */
  /* ISTEM format:                       */
  /*   ISTEM.0 = Number of Items         */
  /*   ISTEM.n = Item name               */
  /*   ISTEM.n.0DATA.0 = Number of data   */
  /*   ISTEM.n.0DATA.m = Data             */
  ISTEMI = 1
  ISTEMJ = 1
  ISTEMM = 0
  ISTEMS = 1
  DLEN = COL - 4
  do forever
     SAVI = ISTEMI
     SAVJ = ISTEMJ
     SAVM = ISTEMM
     SAVS = ISTEMS
     do DROW = 7 to ROW - 1
        REMAIN = DISPISTEMGET()
        call GOTOXY DROW 2; x = charout(,LINE)
     end /* do */
     parse upper value sysgetkey('NOECHO') with KEY
     select
        when KEY = 'E0'x then SP = 1
        when KEY = '00'x then SP = 2
     otherwise
        SP = 0
     end
     if SP <> 0 then parse upper value sysgetkey('NOECHO') with KEY
     select
        when SP = 0 & (KEY = '1B'x | KEY = 'Q') then leave
        when SP = 2 & KEY = '85'x then leave
        when (SP = 0 & KEY = 'N') | (SP = 1 & KEY = '51'x) then do
           ISTEMI = SAVI + 1                     /*  PgDn   Next Item */
           if ISTEMI > ISTEM.0 then ISTEMI = ISTEM.0
           ISTEMJ = 1
           ISTEMM = 0
           ISTEMS = 1
        end
        when (SP = 0 & KEY = 'P') | (SP = 1 & KEY = '49'x) then do
           ISTEMI = SAVI - 1                     /*  PgUp   Prev Item*/
           if ISTEMI < 1 then ISTEMI = 1
           ISTEMJ = 1
           ISTEMM = 0
           ISTEMS = 1
        end  /* Do */
        when (SP = 0 & (KEY = '0D'x | KEY = 'F')) | (SP = 1 & KEY = '50'x) then do
           if SAVM = 0 then do                    /* Fwd 1 line      Down */
              ISTEMM = 1
              ISTEMI = SAVI
              ISTEMJ = SAVJ
              ISTEMS = SAVS
           end  /* Do */
           else do
              ISTEMJ = SAVJ + 1
              ISTEMI = SAVI
              ISTEMM = SAVM
              ISTEMS = 1
              if ISTEMJ > ISTEM.SAVI.0DATA.0 then do
                 ISTEMJ = 1
                 ISTEMI = SAVI + 1
                 if ISTEMI > ISTEM.0 then do
                    ISTEMI = SAVI
                    ISTEMJ = SAVJ
                    ISTEMM = SAVM
                    ISTEMS = SAVS
                 end  /* Do */
                 else ISTEMM = 0
              end  /* Do */
           end  /* Do */
        end
        when (SP = 0 & KEY = 'B') | (SP = 1 & KEY = '48'x) then do
           if SAVM = 0 then do                    /* Up   Bwd 1 line */
              ISTEMM = 1
              ISTEMI = SAVI - 1
              if ISTEMI < 1 then do
                 ISTEMI = SAVI
                 ISTEMJ = SAVJ
                 ISTEMM = SAVM
                 ISTEMS = SAVS
              end  /* Do */
              else ISTEMJ = ISTEM.ISTEMI.0DATA.0
           end  /* Do */
           else do
              ISTEMJ = SAVJ - 1
              if ISTEMJ < 1 then do
                 ISTEMM = 0
                 ISTEMJ = 1
                 ISTEMS = 1
                 ISTEMI = SAVI
                 if ISTEMI < 1 then ISTEMI = 1
              end  /* Do */
              else do
                 ISTEMI = SAVI
                 ISTEMM = 1
              end  /* Do */
           end  /* Do */
        end  /* Do */
        when (SP = 2 & KEY = '3B'x) | (SP = 0 & KEY = '?') then do
           call SETHELP 'FINFO'
           call DISPHELP
           ISTEMI = SAVI
           ISTEMJ = SAVJ
           ISTEMM = SAVM
           ISTEMS = SAVS
        end  /* Do */
     otherwise
        if REMAIN = 0 then do
           KEY = 0
           leave
        end /* do */
     end  /* select */
  end /* do */
return KEY

DISPISTEMGET:
  REMAIN = 1
  if ISTEMM = 0 then do          /* Item name display */
     select
        when ISTEMI = ISTEM.0 + 1 then do
           LINE = ' '||CCLR.2||left('--- End of Data ---'CCLR.0,COL)
           ISTEMI = ISTEMI + 1
        end  /* Do */
        when ISTEMI > ISTEM.0 then do
           REMAIN = 0
           LINE = left(' ',COL - 3)
        end  /* Do */
     otherwise
        LINE = CCLR.0' '||CCLR.2||left('['ISTEM.ISTEMI.0TYPE']'CCLR.0,COL)
        ISTEMM = 1
        ISTEMS = 1
     end  /* select */
  end  /* Do */
  else do                       /* Data display */
     if ISTEMJ > ISTEM.ISTEMI.0DATA.0 then do
        ISTEMI = ISTEMI + 1
        ISTEMJ = 1
        ISTEMM = 0
        LINE = left(' ',COL - 3)
     end  /* Do */
     else do
        if ISTEMS = 1 then do
           LINE = CCLR.0||' '||KJADJ(substr(ISTEM.ISTEMI.0DATA.ISTEMJ,ISTEMS,DLEN))
           ISTEMS = ISTEMS + DLEN
        end
        else do
           LINE = CCLR.0||KJADJ(substr(ISTEM.ISTEMI.0DATA.ISTEMJ,ISTEMS,DLEN+1))
           ISTEMS = ISTEMS + DLEN + 1
        end
        if KJTEST2(left(ISTEM.ISTEMI.0DATA.ISTEMJ,ISTEMS-1)) = 1 then ISTEMS = ISTEMS - 1
        if ISTEMS > length(ISTEM.ISTEMI.0DATA.ISTEMJ) then do
           ISTEMJ = ISTEMJ + 1
           ISTEMS = 1
        end  /* Do */
     end  /* Do */
  end  /* Do */
return REMAIN

FILENAME: procedure
parse arg PATHNAME
  PATHNAME = strip(PATHNAME)
  if POS(' ',PATHNAME) <> 0 | POS('&',PATHNAME) <> 0 then PATHNAME = '"'PATHNAME'"'
return PATHNAME

MSGANDSEL: procedure expose ROW COL CCLR. CUL CH CUR CLL CLR CV MSGSEL.,
                            DEBUGQ DEBUG
  /*  MSGSEL. array format :       */
  /*    MSGSEL.0 = Count Length    */
  /*    MSGSEL.1 = Message         */
  /*    MSGSEL.n = KEY||':'||Item  */
  arg SEL .
  parse value MSGSEL.0 with CNT LEN
  if SEL > CNT | SEL < 2 then SEL = 2
  X = ((ROW - 8 - CNT) % 2) + 5; Y = (COL - LEN - 6) % 2
  C. = CCLR.10; C.SEL = CCLR.12; SP = 0
  do forever
    call GOTOXY X   Y
    XX = charout(,CCLR.10||CUL||copies(CH,LEN+4)||CUR||CCLR.0||' ')
    do I = 1 to CNT
      call GOTOXY X+I Y
      XX=charout(,CCLR.10||CV C.I left(MSGSEL.I,LEN) CCLR.10 CV||CCLR.9||' ')
    end /* do */
    call GOTOXY X+I Y
    XX = charout(,CCLR.10||CLL||copies(CH,LEN+4)||CLR||CCLR.9||' ')
    call GOTOXY X+I+1 Y
    XX = charout(,CCLR.0 CCLR.9||copies(' ',LEN+6))
    parse upper value sysgetkey('NOECHO') with KK
    select
      when KK = 'E0'X then SP = 1
      when KK = '00'X then XX = sysgetkey('NOECHO')  /* discard */
      when SP = 1 & (KK = '48'X | KK = '4B'X) then do    /* UP */
         SP = 0
         TEMP = C.2
         do I = 2 to CNT - 1
            J = I + 1
            C.I = C.J
         end /* do */
         C.CNT = TEMP
      end  /* Do */
      when SP = 1 & (KK = '50'X | KK = '4D'X) then do    /* DOWN */
         SP = 0
         TEMP = C.CNT
         do I = CNT to 3 by -1
            J = I - 1
            C.I = C.J
         end /* do */
         C.2 = TEMP
      end  /* Do */
      when SP = 0 & KK = '0D'X then do   /* Enter */
         do SEL = 2 to CNT
            if C.1 <> C.SEL then leave
         end /* do */
         leave
      end  /* Do */
      when SP = 0 & KK = '1B'X then do   /* Esc */
         SEL = 0; leave
      end  /* Do */
      when SP = 0 then do                /* Serach Alphabet key */
         do I = 2 to CNT
            parse value strip(MSGSEL.I) with KEY ':' .
            if KEY = KK then do
               return I
            end  /* Do */
         end /* do */
      end  /* Do */
      otherwise SP = 0
   end
  end
return SEL

STRCMPX: procedure
/* STRings CoMPare, X value includes wild card                     */
/* This is recursive routine. Recursive call will occure until no  */
/* wild card.                                                      */
/* Input: X, Y   X and Y are strings.  X may contain wild card     */
/* Return: If X matches Y, return 0                                */
  pull Y; pull X
  P = compare(X,Y)
  if P = 0 then return 0      /* compare ok, stop operator */
  select
     when substr(X,P,1) = '?' then do
        push substr(X,P+1)    /* skip single wildcard */
        push substr(Y,P+1)
        return STRCMPX()
     end  /* Do */
     when substr(X,P,1) = '*' then do
        Q = pos('*',substr(X,P+1))+P
        if Q = P then do              /* no more multi-wildcard */
           L = length(substr(X,P+1))  /* compare most right part */
           push substr(X,P+1)
           push right(Y,L)
           return STRCMPX()
        end  /* Do */
        else do
           do I = 0 to length(substr(Y,P))-(Q-P-1) /* serach */
              push substr(X,P+1,Q-P-1)  /* string between multi-wildcards */
              push substr(Y,P+I,Q-P-1)
              RC = STRCMPX()
              if RC = 0 then do         /* compair remaining part */
                 push substr(X,Q)
                 push substr(Y,I+Q-1)
                 return STRCMPX()
              end  /* Do */
           end /* return -1 */
        end  /* Do */
     end  /* Do */
  otherwise
  return -1                   /* Not equal, stop operator */
  end  /* select */
return -1   /* reach here, if do loop expired */

TREEMODE: procedure expose CURRENT DRV TREE. TOTAL FREE VOLID TREELS. ,
                           DTREE. PTREE. TATTR. IDX. CV CH CVL CLL,
                           DRV TREE.  TREEFILE TST TNR ROW COL CUL CUR,
                           CLR CCLR. LTNR NXTREE. NEWDIR ALTT. TREELNAME.,
                           DEBUGQ DEBUG LONGNAMEMODE FD2DLL
arg OPT .
  SAVCURRENT = CURRENT
  if OPT <> '' then do
     if length(OPT) = 1 then OPT = OPT':'
     CURRENT = directory(left(OPT,2))
     if CURRENT = '' then CURRENT = SAVCURRENT
     else if right(CURRENT,2) <> ':\' then CURRENT = CURRENT||'\'
  end
  call GETTREE; call DISPTREE; call DISPITREE
  SP = 0; TMEM = ''
  do forever
     parse upper value sysgetkey('NOECHO') with CMD
     select
        when SP = 0 & CMD = 'E0'X then SP = 1      /* Extended key code */
        when SP = 0 & CMD = '00'X then SP = 2      /* alt key code */
        when SP = 1 & CMD = '48'X then do          /* UP ARROW */
           SP = 0; TNR = TNR - 1                 /* Top */
           if TNR < 1 then TNR = 1
           if TNR < TST then do                  /* Need scroll ? */
             TST = TNR
             call DISPTREE                       /* Full update */
           end  /* Do */
           else call DISPTREE 'X'                /* Partial update */
           call DISPITREE 'X'
        end  /* Do */
        when SP = 1 & CMD = '50'X then do          /* DOWN ARROW */
           SP = 0; TNR = TNR + 1
           if TNR > PTREE.DRV.0 then TNR = PTREE.DRV.0  /* Bottom */
           if TNR > TST + ROW - 8 then do         /* Need scroll */
             TST = TNR - ROW + 8
             call DISPTREE                        /* Full update */
           end
           else call DISPTREE 'X'                 /* Partial update */
           call DISPITREE 'X'
        end  /* Do */
        when SP = 1 & CMD = '51'X then do          /* DOWN */
           SP = 0
           if TST + ROW - 7 <= PTREE.DRV.0 then do
              TST = TST + ROW - 7
              TNR = TST
              call DISPTREE; call DISPITREE 'X'
           end  /* Do */
        end  /* Do */
        when SP = 1 & CMD = '49'X then do          /* UP */
           SP = 0
           TST = TST - ROW + 7
           if TST <  1 then TST = 1
           if TNR > TST + ROW - 8 then TNR = TST
           call DISPTREE; call DISPITREE 'X'
        end  /* Do */
        when SP = 0 & CMD = '0D'X then do          /* CR */
           II = IDX.DRV.TNR
           NEWDIR = directory(PTREE.DRV.II)
           if NEWDIR <> '' then do                /* exsist ? */
              NXTREE.DRV.II = ''
              if right(NEWDIR,2) <> ':\' then NEWDIR = NEWDIR||'\'
              leave
           end
           else do
              NXTREE.DRV.II = 'X'                /* Not exsist */
              call DISPTREE 'X'
           end
        end  /* Do */
        when SP = 0 & CMD = '1B'X then leave       /* ESC */
        when SP = 0 & CMD = 'Q'   then leave       /* QUIT */
        when SP = 2 & CMD = '3B'X then do          /* Help */
           SP = 0
           call SETHELP 'TREE'; call DISPHELP
           call DISPTREE
        end  /* Do */
        when SP = 0 & CMD = 'R'   then do          /* Read */
           call GETTREE 'READ'                     /* Force read */
           call DISPTREE; call DISPITREE
        end
        when SP = 0 & CMD = 'W'   then do          /* Write file */
           TF = PTREE.DRV.1||TREEFILE              /* File name */
           X = stream(TF,'c','query exist')
           if X <> '' then '@ERASE' X
           X = lineout(TF,TREE.DRV.0)
           do I = 1 to TREE.DRV.0
              II = IDX.DRV.I
              X = lineout(TF,TREE.DRV.II)
           end /* do */
           X = lineout(TF,)                 /* Close the file */
        end  /* Do */
        when (SP = 1 & CMD = '47'X) | CMD = '\' then do  /* HOME : top */
           SP = 0; TST = 1; TNR = 1
           call DISPTREE; call DISPITREE 'X'
        end  /* Do */
        when SP = 1 & CMD = '4F'X then do    /* END : bottom */
           SP = 0; TNR = PTREE.DRV.0
           if TST < TNR - ROW + 8 then do
              TST = TNR - ROW + 8
           end  /* Do */
           call DISPTREE; call DISPITREE 'X'
        end  /* Do */
        when SP = 0 & CMD = 'L' then do            /* Logdrive */
           call M_LOGDRIVE
           X = directory(left(SAVCURRENT,2))  /* Back to SAV, for cancel */
           if result = '0D'X then do     /* CURRENT <> SAVCURRENT, maybe */
             call GETTREE
             call DISPTREE; call DISPITREE
           end  /* Do */
           else call DISPTREE
        end  /* Do */
        when SP = 0 & CMD = 'F' then do                   /* Find */
           push '[TREE-FIND] Enter directory name:'; push TMEM
           call MSGANDGET 2
           parse upper pull DN; DN = strip(DN)
           if result <> '1B'X & DN <> '' then do
              TMEM = DN           /* Save serach argument */
              do I = 1 to PTREE.DRV.0
                 II = I + TNR
                 if II > PTREE.DRV.0 then II = II - PTREE.DRV.0
                 INX = IDX.DRV.II; X = DTREE.DRV.II
                 PP = lastpos(CH,X)
                 parse upper value substr(X,PP+2) with TN
                 push DN; push TN
                 if STRCMPX() = 0 then leave
              end /* do */
              TNR = II
              if TNR < TST | (TST + ROW - 8) < TNR then do
                 TST = TNR - ((ROW - 8) % 2)
                 if TST < 1 then TST = 1
              end
           end
           call DISPTREE; call DISPITREE 'X'
        end  /* Do */
        when SP = 2 then do                    /* ALT+  */
            SP = 0; C = c2x(CMD); A = ALTT.C   /* ALT code -> Alpha. */
            if A <> '' then do                 /* ALT+alphabet ? */
               do I = 1 to PTREE.DRV.0
                  II = I + TNR
                  if II > PTREE.DRV.0 then II = II - PTREE.DRV.0
                  INX = IDX.DRV.II; X = lastpos(CH,DTREE.DRV.II)
                  parse upper value substr(DTREE.DRV.II,X+2,1) with XX
                  if XX = A then leave
               end /* do */
               TNR = II
               if TNR < TST | (TST + ROW - 8) < TNR then do
                  TST = TNR - ((ROW - 8) % 2)
                  if TST < 1 then TST = 1
               end
               call DISPTREE; call DISPITREE 'X'
            end  /* Do */
        end  /* Do */
        otherwise SP = 0
     end
  end
  CURRENT = SAVCURRENT
  LEN = length(CURRENT) - 1; if LEN < 3 then LEN = 3
  X = directory(left(CURRENT,LEN))
  if CMD = 'Q' then CMD = '1B'X
return CMD

DISPTREE: procedure expose DRV DTREE. PTREE. TATTR. IDX. TST TNR ROW COL,
                           CCLR. LTNR NXTREE. CH TREELNAME. DEBUGQ DEBUG,
                           LONGNAMEMODE
  /* Usage: call DISPTREE      ...  Full update              */
  /*        call DISPTREE 'X'  ...  Partial update           */
  /*        Partial update routine will call itself twice.   */
  /*        They are 'call DISPTREE LTNR' and 'call DISPTREE */
  /*        TNR'. LTNR = Lagging TNR, TNR = Tree number      */
  arg OPT .
  if OPT = '' then do
    XSTART = 0; XEND = ROW - 8   /* Full update setup */
  end
  else do                        /* Partial update */
     if datatype(OPT) = 'NUM' then do
        XSTART = OPT - TST
        XEND = OPT - TST
     end  /* Do */
     else do
        call DISPTREE LTNR       /* Re-display previous TNR */
        call DISPTREE TNR        /* Re-display TNR */
        return                   /* End of partial update front end */
     end  /* Do */
  end  /* Do */
  PP = ((TNR-1)%(ROW-7))+1||'/'||format((PTREE.DRV.0-1)%(ROW-7)+0.5,,0)
  call GOTOXY 2 8; XX = charout(,CCLR.0||left(PP,5))  /* Display page count */
  do I = XSTART to XEND
     P = TST + I; PI = IDX.DRV.P
     if P > PTREE.DRV.0 then do
       call GOTOXY I+7 2
       X = charout(,copies(' ',COL-3))
     end
     else do
       select
          when substr(TATTR.DRV.PI,5)='S'   & TNR <> P then AT = CCLR.3
          when substr(TATTR.DRV.PI,3,1)='H' & TNR <> P then AT = CCLR.4
          when substr(TATTR.DRV.PI,4,1)='R' & TNR <> P then AT = CCLR.5
          when substr(TATTR.DRV.PI,5)='S'   & TNR = P then AT = CCLR.13
          when substr(TATTR.DRV.PI,3,1)='H' & TNR = P then AT = CCLR.14
          when substr(TATTR.DRV.PI,4,1)='R' & TNR = P then AT = CCLR.15
          otherwise do
             if TNR <> P then AT = CCLR.7
             else AT = CCLR.19
          end
       end  /* select */
       if NXTREE.DRV.PI = 'X' then do      /* Not exsist */
          if TNR <> P then AT = CCLR.17
          else AT = CCLR.18
       end  /* Do */
       call GOTOXY I+7 2
       LINE = DTREE.DRV.P; WI = lastpos(CH,LINE)
       CI =  (COL - 3) / 2 - length(LINE)
       if CI < 0 then CI = 3 * (COL - 3) / 4 - length(LINE)
       parse value CI with CI '.' .

       if LONGNAMEMODE = 'ON' then do
          if symbol('TREELNAME.DRV.PI') <> 'VAR' then do
             LNAMEINFO = ''
             X = SysGetEA(PTREE.DRV.PI,'.LONGNAME','LNAMEINFO')          /* Get Ext Attrib */
             if LNAMEINFO <> '' then do
                call EAANAL LNAMEINFO
                TREELNAME.DRV.PI = EASTEM.1
                do J = 2 to EASTEM.0
                   TREELNAME.DRV.PI = TREELNAME.DRV.PI'^'EASTEM.J
                end /* do */
             end
             else TREELNAME.DRV.PI = ''
          end  /* Do */
       end  /* Do */

       if symbol('TREELNAME.DRV.PI') = 'VAR' then TLN = TREELNAME.DRV.PI
       else TLN = ''
       if CI < 0 then LINE = left(LINE,WI)||AT substr(LINE,WI+2) CCLR.0
       else LINE = left(LINE,WI)||AT substr(LINE,WI+2) CCLR.0 copies(' ',CI) TLN
       TLEN = COL - 3 + length(AT||CCLR.0)
       X = charout(,KJADJ(left(LINE,TLEN)))
     end
  end /* do */
  LTNR = TNR
return

GETTREE: procedure expose CURRENT DTREE. PTREE. TATTR. IDX. CV CH CVL CLL,
                          DRV TREE. CCLR. TREEFILE TST TNR ROW COL CUL CUR,
                          CLR TREELS. NXTREE. TREELNAME. DEBUGQ DEBUG
arg OPT                        /* if OPT was specified set force read */
  DRV = c2d(left(CURRENT,1)) - 65
  RTREE = left(CURRENT,3)
  /* Following if/then/do block is very BIG ! (almost entire routone) */
  if symbol('DTREE.DRV.0')='LIT' | DRV=0 | DRV=1 | OPT<>'' then do
    TF = d2c(DRV+65)||':\'||TREEFILE; RC = stream(TF,'c','query exists')
    call RUNMSG
    if RC = '' | OPT <> '' then do
       call SysFileTree RTREE, 'T','DS'
       TREELS.DRV = 'DIRECTORY'
    end
    else do                              /* Reading form file */
/*       RC = stream(TF,'c','close') */
       T.0 = linein(TF) - 1; X = linein(TF)
       do I = 1 to T.0
          X = linein(TF)
          T.I = subword(X,1,4) left(CURRENT,1)||substr(subword(X,5),2)
       end /* do */
       RC = stream(TF,'c','close')
       TREELS.DRV = TF stream(TF,'c','query datetime')
    end  /* Do */

    do I = 1 to T.0      /* Extract attribute and pathname */
       IP = I + 1; TREE.DRV.IP = T.I; NXTREE.DRV.IP = ''
       TATTR.DRV.IP = word(T.I,4); PTREE.DRV.IP = subword(T.I,5)
       STREE.DRV.IP = translate(PTREE.DRV.IP,' ','\')
       drop TREELNAME.DRV.IP
    end /* do */
    PTREE.DRV.1 = RTREE; PTREE.DRV.0 = T.0 + 1
    TATTR.DRV.1 = ''; TREE.DRV.1 = ''; TREE.DRV.0 = T.0 + 1

    /*  SORT routine (COM-SORT-11)  */
    do I = 1 to PTREE.DRV.0; IDX.DRV.I = I; end        /* init the InDeX */
    GAP = PTREE.DRV.0                              /* initial GAP value */
    do until (SW = 0) & (GAP = 1)          /* SW=0 means no change occured */
       GAP = trunc(GAP / 1.3)              /* 1.3 : GAP shrink factor */
       select                              /* Modify the GAP */
          when GAP = 0  then GAP = 1
          when GAP = 9  then GAP = 11
          when GAP = 10 then GAP = 11
          otherwise nop
       end  /* select */
       SW = 0
       TOP = PTREE.DRV.0 - GAP
       do I = 2 to TOP
          J = I + GAP
          II = IDX.DRV.I; IJ = IDX.DRV.J             /* Indexing */
          if STREE.DRV.II >> STREE.DRV.IJ then do
             IDX.DRV.I = IJ; IDX.DRV.J = II; SW = 1  /* Swap */
          end  /* Do */
       end /* do */
    end /* do */
    /* End of sort routine */

    SAVT. = ''; SAVB. = 0
    do I = PTREE.DRV.0 to 2 by -1      /* scaning from bottom */
       II = IDX.DRV.I                  /* indexing */
       XTPATH = PTREE.DRV.II
       XTEMP. = ''; XI = 2

       do forever             /* convert '\' -> ' ' */
          parse value XTPATH with '\' DNAME '\' REMAINS
          if KJTEST(right(DNAME,1)) = 1 then do
            DBCSPATH = DNAME||'\'||REMAINS; KJ = 0     /* DBCS process */
            do NLS = 1 to length(DBCSPATH)
               if KJ = 0 then do
                 NC = substr(DBCSPATH,NLS,1)
                 KJ = KJTEST(NC)
                 if NC = '\' then do
                    NLS = NLS - 1; leave
                 end  /* Do */
               end
               else KJ = 0
            end
            DNAME = left(DBCSPATH,NLS)
            REMAINS = substr(DBCSPATH,NLS+2)
          end  /* Do */                             /* End of DBCS process */
          XTEMP.XI = DNAME; XI = XI + 1
          if REMAINS = '' then leave
          XTPATH = '\'||REMAINS
       end /* do */
       XTEMP.1 = RTREE

       WS = XI - 1
       do J = WS to 1 by -1             /* scanning right to left */
          if J = WS then DTREE.DRV.I = XTEMP.J       /* Most right */
          else do
            if J = WS - 1 then do                      /* 2nd from right */
               if XTEMP.J = SAVT.J then do             /* Bottom ?*/
                  if XSAVT.J = 1 then do               /* not bottom */
                     BRANCH = CVL||CH||CH              /* prev is not blank */
                  end
                  else do
                     BRANCH = CLL||CH||CH; XSAVT.J = 1 /* prev is blank */
                  end  /* Do */
               end
               else do
                  BRANCH = CLL||CH||CH; XSAVT.J = 1    /* bottom */
               end
            end  /* Do */
            else do                                    /* 3rd or more left */
               if XTEMP.J = SAVT.J then do             /* bottom ?*/
                  if XSAVT.J = 0 then BRANCH = '   '   /* prev is blank */
                  else BRANCH = CV||'  '               /* prev is not blank */
               end  /* Do */
               else do
                  BRANCH = '   '; XSAVT.J = 0          /* bottom */
               end  /* Do */
            end  /* Do */
            DTREE.DRV.I = BRANCH DTREE.DRV.I
          end
       end /* do */

       do WS = 1 to XI; SAVT.WS = XTEMP.WS; end
       DTREE.DRV.I = '   '||DTREE.DRV.I
    end /* do */
    DTREE.DRV.0 = PTREE.DRV.0; DTREE.DRV.1 = ' '||RTREE
  end   /* End of B I G if/then/do/end block */
  /* Positioning */
  do TNR = 1 to PTREE.DRV.0
     II = IDX.DRV.TNR
     parse upper value CURRENT PTREE.DRV.II'\' with X Y
     if X = Y then leave
  end /* do */
  if TNR > PTREE.DRV.0 then TNR = 1
  TST = TNR - ((ROW - 8) % 2); if TST < 1 then TST = 1
return

FSORT: procedure expose FNAME. FILE. BYTES. TYPE. FIDX. FSORTKEY FSORTORD,
                        LNAME. DEBUGQ DEBUG ROW

    if FSORTKEY = 'NONE' then do
       if FSORTORD = 'R' then do
          do I = 1 to FIDX.0       /* reverse order */
             FIDX.I = FIDX.0 - I + 1
          end /* do */
       end  /* Do */
       else do
          do I = 1 to FIDX.0       /* restore original order */
             FIDX.I = I
          end /* do */
       end  /* Do */
       return                      /* Return */
    end  /* Do */

    do I = 0 to FIDX.0             /* Copy previous index */
       II = FIDX.I; CI.II = I      /* to make stable sort.    */
    end /* do */

    /*  SORT routine (COM-SORT-11)  */
    GAP = FIDX.0                           /* initial GAP value */
    do until (SW = 0) & (GAP = 1)          /* SW=0 means no change occured */
       GAP = trunc(GAP / 1.3)              /* 1.3 : GAP shrink factor */
       select                              /* Modify the GAP */
          when GAP = 0  then GAP = 1       /* Equivalent to bubble sort */
          when GAP = 9  then GAP = 11
          when GAP = 10 then GAP = 11
          otherwise nop
       end  /* select */
       SW = 0
       TOP = FIDX.0 - GAP
       do I = 1 to TOP
          J = I + GAP
          II = FIDX.I; IJ = FIDX.J           /* Indexing */
          select
             when FSORTKEY = 'NAME' then do
               LP = lastpos('.',FNAME.II)
               if LP <> 0 then LEFT = left(FNAME.II,LP-1)
               else LEFT = FNAME.II
               parse upper value LEFT||'A' with LEFT  /* 'A' prevents numeric compare */
               LP = lastpos('.',FNAME.IJ)
               if LP <> 0 then RIGHT = left(FNAME.IJ,LP-1)
               else RIGHT = FNAME.IJ
               parse upper value RIGHT||'A' with RIGHT
             end  /* Do */
             when FSORTKEY = 'TYPE' then do
               LP = lastpos('.',FNAME.II)
               if LP <> 0 then do
                  LEFT = substr(FNAME.II,LP+1)
                  parse upper value LEFT||'A' with LEFT
               end  /* Do */
               else LEFT = ''
               LP = lastpos('.',FNAME.IJ)
               if LP <> 0 then do
                  RIGHT = substr(FNAME.IJ,LP+1)
                  parse upper value RIGHT||'A' with RIGHT
               end  /* Do */
               else RIGHT = ''
             end  /* Do */
             when FSORTKEY = 'DATE' then do
               LEFT  = subword(FILE.II,words(FILE.II)-2)
               RIGHT = subword(FILE.IJ,words(FILE.IJ)-2)
             end  /* Do */
             when FSORTKEY = 'SIZE' then do
               LEFT  = BYTES.II
               RIGHT = BYTES.IJ
             end  /* Do */
             otherwise do
               say 'Error !'; return
             end
          end  /* select */
          if FSORTORD = 'R' then do        /*  vvvvvvvvvvvvv  2nd sort key */
             if LEFT < RIGHT | (LEFT = RIGHT & CI.II < CI.IJ) then do
                FIDX.I = IJ; FIDX.J = II; SW = 1    /* Swap */
             end  /* Do */
          end  /* Do */
          else do
             if LEFT > RIGHT | (LEFT = RIGHT & CI.II > CI.IJ) then do
                FIDX.I = IJ; FIDX.J = II; SW = 1    /* Swap */
             end  /* Do */
          end  /* Do */
       end /* do */
    end /* do */
    /* End of sort routine */
return

MSGANDYN: procedure expose ROW COL CCLR. CUL CUR CV CH CLL CLR DEBUGQ DEBUG
  parse pull MSG
  LL = length(MSG)
  X = ((ROW - 6) % 2) + 5; Y = (COL - LL - 2) % 2
  C1 = CCLR.12; C2 = CCLR.10; SP = 0
  do forever
    call GOTOXY X-3 Y
    XX = charout(,CCLR.10||CUL||copies(CH,LL+2)||CUR||CCLR.0||' ')
    call GOTOXY X-2 Y
    XX = charout(,CCLR.10||CV||copies(' ',LL+2)||CV||CCLR.9||' ')
    call GOTOXY X-1 Y
    XX = charout(,CCLR.10||CV MSG CV||CCLR.9||' ')
    call GOTOXY X   Y
    XX = charout(,CCLR.10||CV C1 left('Y:Yes',LL-2) CCLR.10 CV||CCLR.9||' ')
    call GOTOXY X+1 Y
    XX = charout(,CCLR.10||CV C2 left('N:No',LL-2) CCLR.10 CV||CCLR.9||' ')
    call GOTOXY X+2 Y
    XX = charout(,CCLR.10||CV||copies(' ',LL+2)||CV||CCLR.9||' ')
    call GOTOXY X+3 Y
    XX = charout(,CCLR.10||CLL||copies(CH,LL+2)||CLR||CCLR.9||' ')
    call GOTOXY X+4 Y
    XX = charout(,CCLR.0 CCLR.9||copies(' ',LL+4))
    parse upper value sysgetkey('NOECHO') with KK
    select
      when KK = 'E0'X then SP = 1
      when SP = 0 & (KK = 'Y' | KK = 'N')  then leave
      when KK = '00'X then XX = sysgetkey('NOECHO')  /* discard */
      when SP = 1 & (KK = '48'X | KK = '4B'X) then do     /* UP */
         SP = 0; TEMP = C1; C1 = C2; C2 = TEMP
      end  /* Do */
      when SP = 1 & (KK = '50'X | KK = '4D'X) then do    /* DOWN */
         SP = 0; TEMP = C2; C2 = C1; C1 = TEMP
      end  /* Do */
      when SP = 0 & KK = '0D'X then do
         if C1 = CCLR.12 then KK = 'Y'
         else KK = 'N'
         leave
      end  /* Do */
      when SP = 0 & KK = '1B'X then leave
      otherwise nop
    end
    if KK = 'Y' | KK = 'N' | KK = '1B'X then leave
  end
  if KK <> 'Y' then KK = '1B'X
return KK

BROWSE:
  arg FN
  call RUNMSG
  if VIEWER ='' then do
     call CLS
     '@more <' FILENAME(FN)
     XX = charout(,'Press enter key to return'); pull XX
  end  /* Do */
  else do
     RC = EXECUTE(FILENAME(FN), , VIEWER)
     if RC <> 0 then do
        say 'Error !    RC =' RC
        XX = charout(,'Press enter key to return'); pull XX
     end  /* Do */
  end  /* Do */
  call CLS
  call DISPFRAME
  call DISPFILE
  call DISPINFO
return

GETDISP:
arg OPT , OPT2
   call CLS
   call DISPFRAME
   call GETFILES
   if OPT = 'NOSORT' then do
      FSORTKEY = 'NONE'
      FSORTORD = 'N'
   end  /* Do */
   else call FSORT

   if symbol('FPLIST.CURRENT') = 'VAR' then do
      X = FPLIST.CURRENT.0; X = FIDX.X
      if FPLIST.CURRENT = FNAME.X then do
         NR = FPLIST.CURRENT.0; FST = FPLIST.CURRENT.1
      end  /* Do */
   end  /* Do */

   if OPT2 = '' then do
      call DISPFILE
      call DISPINFO
   end  /* Do */
return

RUNMSG: procedure expose CUL CH CUR CV CLL CLR CCLR. ROW COL DEBUGQ DEBUG
   parse arg MSG
   if MSG = '' then MSG = 'Running...'
   LMSG = length(MSG); Y = (COL-LMSG-3) % 2
   X = ((ROW - 6) % 2) + 5
   call GOTOXY X-2 Y
   XX = charout(,CCLR.8||CUL||copies(CH,LMSG+4)||CUR||CCLR.0||' ')
   call GOTOXY X-1 Y
   XX = charout(,CCLR.8||CV left(' ',LMSG+2) CV||CCLR.9||' ')
   call GOTOXY X   Y
   XX = charout(,CCLR.8||CV CCLR.8 MSG CCLR.8 CV||CCLR.9||' ')
   call GOTOXY X+1 Y
   XX = charout(,CCLR.8||CV left(' ',LMSG+2) CV||CCLR.9||' ')
   call GOTOXY X+2 Y
   XX = charout(,CCLR.8||CLL||copies(CH,LMSG+4)||CLR||CCLR.9||' ')
   call GOTOXY X+3 Y
   XX = charout(,CCLR.0 CCLR.9||copies(' ',LMSG+6))
return

CMDEXEC: procedure expose HIST. CUL CH CUR CV CLL CLR CCLR. ROW COL DEBUGQ DEBUG
   parse pull RES
   HR = HIST.0 + 1; HIST.0 = HR; HIST.HR = RES
   do forever
     parse upper value right(strip(RES),5) with EXT '"'
     parse value right(EXT,4) with '.' EXT
     if EXT='CMD' | EXT='EXE' | EXT='COM' | EXT='BAT' then MODE = 1
     else MODE = 0
     push 'Execute'; push RES
     call MSGANDGET MODE; KEY = result
     parse pull RES
     select
        when KEY = '48'X then do      /* up arrow */
           HR = HR - 1; if HR < 1 then HR = HIST.0
           RES = HIST.HR
        end  /* Do */
        when KEY = '50'X then do      /* down arrow */
           HR = HR + 1; if HR > HIST.0 then HR = 1
           RES = HIST.HR
        end  /* Do */
        otherwise leave
     end
   end
   if KEY = '1B'X then RES = ''
   HR = HIST.0; H = HR - 1
   if (strip(HIST.H) \= strip(RES)) & (strip(RES) \= '') then HIST.HR = RES
   else HIST.0 = HR - 1
   push RES
return KEY

MSGANDGET: procedure expose CUL CH CUR CV CLL CLR CCLR. ROW COL HIST. DEBUGQ DEBUG
   arg MODE .
   /*  MODE 1 : Puts cursor right end              */
   /*       2 : No history support (Up/Down arrow) */
   parse pull TEMP; parse pull MSG
   X = ((ROW - 6) % 2) + 5
   call GOTOXY X-2 3
   XX = charout(,CCLR.10||CUL||copies(CH,COL-7)||CUR||CCLR.0||' ')
   call GOTOXY X-1 3
   XX = charout(,CCLR.10||CV left(MSG,COL-8)||CV||CCLR.9||' ')
   call GOTOXY X   3
   XX=charout(,CCLR.10||CV CCLR.11||left(TEMP,COL-9)||CCLR.10 CV||CCLR.9||' ')
   call GOTOXY X+1 3
   XX = charout(,CCLR.10||CLL||CH 'INS' copies(CH,COL-13)||CLR||CCLR.9||' ')
   call GOTOXY X+2 3; XX = charout(,CCLR.0 CCLR.9||copies(' ',COL-5))
   call GOTOXY X   5; XX = charout(, CCLR.11)
   if MODE = 1 then call GOTOXY X length(strip(TEMP,'T'))+6
   SP = 0; INS = 1; KJ1 = ''; KJST = ''
   KPOS = length(TEMP); KJ = 0
   do I = 1 to KPOS
      if KJ = 1 then do
         KJST = KJST||'0'; KJ = 0
      end  /* Do */
      else do
         if KJTEST(substr(TEMP,I,1)) = 1 then KJ = 1
         KJST = KJST||'1'
      end  /* Do */
   end /* do */
   RES = TEMP
   parse value syscurpos() with XP YP
   do forever
      if YP < 4 then YP = 4
      if YP > COL-6 then YP = COL-6
      if substr(KJST,COL-8,1) = 0 then KJA = 1
      else KJA = 0
      RES = left(RES,COL-9-KJA); KJST = left(KJST,COL-9-KJA)
      if substr(KJST,YP-3,1) = 0 then YP = YP - 1
      call gotoxy X 5; say RES
      call gotoxy XP+1 YP+1
      call syscurstate 'ON'
      KEY = sysgetkey('NOECHO')
      call syscurstate 'OFF'
      select
         when KEY = 'E0'X then SP = 1           /* exp key */
         when KEY = '00'X then SP = 2           /* alt key */
         when SP = 0 & KJTEST(KEY) = 1 then do  /* Kanji */
           SP = 3; KJ1 = KEY
         end
         when SP = 0 & KEY = '0A'X then leave   /* LF */
         when SP = 0 & KEY = '0D'X then leave   /* CR */
         when SP = 0 & KEY = '1B'X then leave   /* ESC */
         when SP = 1 & KEY = '48'X & MODE<>2 then leave   /* up arrow */
         when SP = 1 & KEY = '50'X & MODE<>2 then leave   /* down arrow */
         when SP = 0 & KEY = '09'X then do      /* TAB */
            YP = YP + 8
         end  /* Do */
         when SP = 2 & KEY = '0F'X then do      /* Shift + TAB */
            SP = 0; YP = YP - 8; if YP < 4 then YP = 4
         end  /* Do */
         when SP = 1 & KEY = '52'X then do      /* INS */
            INS = \INS; SP = 0
            call GOTOXY X+1 5; XX = charout(,CCLR.10)
            if INS = 1 then XX = charout(,' INS ')
            else XX = charout(,copies(CH,5))
            call GOTOXY XP+1 YP+1; XX = charout(,CCLR.11)
         end  /* Do */
         when SP = 1 & KEY = '53'X then do      /* DEL */
            if substr(KJST,YP-2,1) = 0 then KJA = 1
            else KJA = 0
            RES = left(RES,YP-4)||substr(RES,YP-2+KJA)
            KJST = left(KJST,YP-4)||substr(KJST,YP-2+KJA)
            /* call GOTOXY XP+1 YP+1 */
            SP = 0
         end  /* Do */
         when SP = 1 & KEY = '4D'X then do      /* Right arrow */
            YP = YP + 1; SP = 0
            if substr(KJST,YP-3,1) = 0 then YP = YP + 1
         end
         when SP = 1 & KEY = '4B'X then do      /* Left arrow */
            SP = 0; YP = YP - 1; if YP < 4 then YP = 4
         end
         when (SP = 2 & KEY = '9B'X) | (SP = 1 & KEY = '73'X) then do
            YP = 4; SP = 0
         end
         when (SP = 2 & KEY = '9D'X) | (SP = 1 & KEY = '74'X) then do
            YP = length(strip(RES,T))+5
            SP = 0
         end
         when SP = 0 & KEY = '08'X then do     /* BS */
            YPKJ = YP - 5
            if YPKJ >= 0 then do
              if substr(KJST,YPKJ+1,1) = 0 then KJA = 1
              else KJA = 0
              RES = left(RES,YPKJ-KJA)||substr(RES,YPKJ+2)
              KJST = left(KJST,YPKJ-KJA)||substr(KJST,YPKJ+2)
              YP = YP - KJA - 1
            end
         end  /* Do */
         when SP = 1 then SP = 0
         when SP = 2 then SP = 0
         when SP = 0 | SP = 3 then do
            if SP = 3 then do
               KJSP = 1; KJSTAT = '10'
            end
            else do
               KJSP = 0; KJSTAT = '1'
            end
            SP = 0; YPKJ = YP - 4
            if INS = 1 then do
               RES = left(RES,YPKJ)||KJ1||KEY||substr(RES,YP-3)
               KJST = left(KJST,YPKJ)||KJSTAT||substr(KJST,YP-3)
            end
            else do
               if substr(KJST,YP-2,1) = 0 then KJA = 1
               else KJA = 0
               RES = left(RES,YPKJ)||KJ1||KEY||substr(RES,YP-2+KJA)
               KJST = left(KJST,YPKJ)||KJSTAT||substr(KJST,YP-2+KJA)
            end  /* Do */
            YP = YP + 1 + KJSP; KJ1 = ''
         end  /* Do */
         otherwise
      end  /* select */
   end /* do */
   push RES
return KEY

DOWNARROW:
  SP = 0; NR = NR + 1; if NR > FCOUNT then NR = FST
  if NR >= (NX * NY + FST) then NR = FST
  call DISPFILE 'X'; call DISPINFO 'X'
return

SETDISPM:
  arg DISPMODE
  select
     when left(DISPMODE,1) = 1 then do
        LFILE = 45
        DISPMODE1SAV = DISPMODE
     end  /* Do */
     when DISPMODE = 2 then LFILE = 38
     when DISPMODE = 3 then LFILE = 22
     when DISPMODE = 5 then LFILE = 13
     otherwise call SETDISPM 2
  end  /* select */
return

GETFILES: procedure expose CURRENT FILE. FBYTES FCOUNT TYPE. ATTR. FST NR ,
                           FNAME. ROW COL CCLR. BYTES. MBYTES MCOUNT MASK. ,
                           FLM CUL CH CUR CV CLL CLR TOTAL FREE VOLID FIDX. ,
                           LNAME. CDROM. DEBUGQ DEBUG LONGNAMEMODE CDROMINDEX,
                           EACOMMENTS
  X = ((ROW - 6) % 2) + 5; Y = (COL - 20) % 2
  call GOTOXY X-2 Y
  XX = charout(,CCLR.8||CUL||copies(CH,23)||CUR||CCLR.0||' ')
  call GOTOXY X-1 Y
  XX = charout(,CCLR.8||CV||'                       '||CV||CCLR.9||' ')
  call GOTOXY X   Y
  XX = charout(,CCLR.8||CV||' Reading the directory '||CV||CCLR.9||' ')
  call GOTOXY X+1 Y
  XX = charout(,CCLR.8||CV||'                       '||CV||CCLR.9||' ')
  call GOTOXY X+2 Y
  XX = charout(,CCLR.8||CLL||copies(CH,23)||CLR||CCLR.9||' ')
  call GOTOXY X+3 Y
  XX = charout(,CCLR.0 CCLR.9||'                         ')
  parse value sysdriveinfo(left(CURRENT,2)) with . FREE TOTAL VOLID
  VOLID = strip(VOLID)
  FILE. = ''; TYPE. = ''; FBYTES = 0; FST = 1; NR = 1; MBYTES = 0; MCOUNT = 0
  FNAME. = ''; MASK. = ' '; FLM = 0; BYTES. = 0; FIDX. = ''; LNAME. = ''
  TYPEINFO = ''; LNAMEINFO = ''

  drop CDROM. CDROMT.       /* Reading index file */
  if CDROMINDEX = 'ON' then do
    INDEXFILE = CURRENT||'00_INDEX.TXT'
    select
       when left(VOLID,2) = 'VD' then do   /* Vector Design PACKxxxx suuport */
          VDHOME = 0
          do while lines(INDEXFILE) = 1
             parse value linein(INDEXFILE) with 1 IFNAME +12 . +1 ITEXT
             IFNAME = word(IFNAME,1)||word(IFNAME,2)
             if length(CURRENT) = 3 then do
                if IFNAME = '\' then VDHOME = 1
                if VDHOME <> 1 then iterate
                if left(IFNAME,1) = '\' & length(IFNAME) > 1 then leave
             end  /* Do */
             if IFNAME = '' then CDROMT.SAVIFNAME = SAVITEXT||substr(ITEXT,24)
             if right(IFNAME,1) = '\' then do
                IFNAME = left(IFNAME,length(IFNAME)-1)
                ITEXT = subword(ITEXT,4)
             end  /* Do */
             else ITEXT = subword(ITEXT,3,2)||'  '||subword(ITEXT,5)
             parse upper value translate(IFNAME,'^','.') with IFNAME
             CDROMT.IFNAME = strip(ITEXT)
             SAVIFNAME = IFNAME
             SAVITEXT = CDROMT.IFNAME
          end  /* Do */
       end /* do */
       when left(VOLID,6) = 'HOBBES' then do   /* HOBBES OS/2 */
          do while lines(INDEXFILE) = 1
             parse value linein(INDEXFILE) with IFNAME ITEXT
             if right(IFNAME,1) = '\' then IFNAME = left(IFNAME,length(IFNAME)-1)
             if IFNAME = '|' then CDROMT.SAVIFNAME = SAVITEXT ITEXT
             if length(CURRENT) > 3 then ITEXT = subword(ITEXT,3)
             parse upper value translate(IFNAME,'^','.') with IFNAME
             CDROMT.IFNAME = strip(ITEXT)
             SAVIFNAME = IFNAME
             SAVITEXT = CDROMT.IFNAME
          end  /* Do */
       end /* do */
       when left(VOLID,8) = 'UNIXUSER' then do  /* Unix User */
          INDEXFILE = '00_TRANS.TBL'
          do while lines(INDEXFILE) = 1
             parse value linein(INDEXFILE) with . IFNAME ITEXT
             if right(IFNAME,1) = '.' then IFNAME = left(IFNAME,length(IFNAME)-1)
             parse upper value translate(IFNAME,'^','.') with IFNAME
             CDROMT.IFNAME = strip(ITEXT)
          end  /* Do */
       end  /* Do */
    otherwise
       do while lines(INDEXFILE) = 1           /* OS/2 Magazine ... */
          parse value linein(INDEXFILE) with IFNAME ITEXT
          if IFNAME = '\' then leave
          if right(IFNAME,1) = '\' then IFNAME = left(IFNAME,length(IFNAME)-1)
          parse upper value translate(IFNAME,'^','.') with IFNAME
          CDROMT.IFNAME = strip(ITEXT)
       end  /* Do */
    end  /* select */
    x = stream(INDEXFILE,'c','close')
  end  /* Do */

  call SysFileTree CURRENT,'FILE','BT'    /* get directory information */
  FCOUNT = FILE.0; FIDX.0 = FCOUNT
  do I=1 to FCOUNT
     FIDX.I = I                               /* Initialize file index */
     parse value FILE.I with DT BYTE ATR FL
     ATTR.I = ATR; BYTES.I = BYTE
     FBYTES = FBYTES + BYTE                            /* Total Bytes */
     DT = overlay(':',overlay(' ',DT,9),12)            /* Date and Time */
     FNAME.I = filespec('name',FL)                     /* extract filename */
     if KJTEST(left(right(filespec('path',FL),2),1)) = 1 then do
        KJ = 0                                         /* DBCS process */
        do NLS = 1 to length(FL)
          if KJ = 0 then do
            NC = substr(FL,NLS,1)
            if KJTEST(NC) = 1 then KJ=1
            else if NC = '\' then DBCSPOS = NLS
          end  /* Do */
          else KJ = 0
        end /* do */
        FNAME.I = substr(FL,DBCSPOS+1)
     end  /* Do */                                 /* End of DBCS process */
     LL = length(FNAME.I); if LL > FLM then FLM = LL  /* Fname length MAX */
     if substr(ATR,2,1) = 'D' then BYTE = '< DIR >'

     IFNAME = translate(FNAME.I,'^','.')
     if symbol('CDROMT.IFNAME') = 'VAR' then do
        EA = '+'
        CDROM.I = CDROMT.IFNAME
     end
     else EA = ' '

     if EACOMMENTS = 'ON' then do
        X = SysGetEA(FNAME.I,'.COMMENTS','TYPEINFO')          /* Get Ext Attrib */
        if TYPEINFO <> '' then do
          call EAANAL TYPEINFO
          TYPE.I = EASTEM.1
          do J = 2 to EASTEM.0
            TYPE.I = TYPE.I'^'EASTEM.J
          end /* do */
          EA = '+'
        end
     end  /* Do */
     if LONGNAMEMODE = 'ON' then do
        X = SysGetEA(FNAME.I,'.LONGNAME','LNAMEINFO')          /* Get Ext Attrib */
        if LNAMEINFO <> '' then do
          call EAANAL LNAMEINFO
          LNAME.I = EASTEM.1
          do J = 2 to EASTEM.0
            LNAME.I = LNAME.I'^'EASTEM.J
          end /* do */
          EA = '+'
        end
     end  /* Do */
     FILE.I = right(BYTE,10)||EA||' '||DT||' '||ATR
  end
  if FLM < 12 then FLM = 12                      /* Minmum FLM is 12 (8.3) */
return

DISPINFO: procedure expose COL CCLR. CURRENT LNAME. TYPE. FILE. FBYTES MBYTES,
                           FCOUNT MCOUNT NR FNAME. TOTAL FREE VOLID FIDX.,
                           CDROM. DEBUGQ DEBUG ROW
arg OPT
  INR = FIDX.NR
  FI = 82 - COL; if FI < 1 then FI = 1
  TY = COL - 13; if TY < 0 then TY = 0
  call GOTOXY 4 13                                   /* File info: */
  XX = charout(,CCLR.0||left(KJADJ(left(FNAME.INR,12))||substr(FILE.INR,FI),COL-36))
  call GOTOXY 4 COL-24; XX = charout(,right(MCOUNT,4))      /* XX Marked */
  call GOTOXY 4 COL-14; call charout,delimit3(MBYTES,13)     /* Marked XX */
  call GOTOXY 5 12                                          /* Comment: XX */
  select
     when symbol('CDROM.INR') = 'VAR' then LINE = CDROM.INR
     when TYPE.INR <> '' then LINE = TYPE.INR
  otherwise
     LINE = LNAME.INR
  end  /* select */
  XX = charout(,KJADJ(left(LINE,TY)))
  if OPT = '' then do
    CU = COL - 32; if CU < 0 then CU = 0
    call GOTOXY 3 8     ; XX = charout(,KJADJ(left(CURRENT,CU)))   /* Path=XX */
    call GOTOXY 3 COL-24; XX = charout(,right(FCOUNT,4))    /* XX Files */
    call GOTOXY 3 COL-15; call charout,delimit3(FBYTES,14)   /* Files XX */
    Y = (COL - 9) % 4
    call GOTOXY 2 19; call charout,delimit3(TOTAL,Y-6)        /* Total:XX */
    call GOTOXY 2 18+Y; call charout,delimit3(TOTAL-FREE,Y-5) /* Used:XX */
    call GOTOXY 2 18+Y+Y; call charout,delimit3(FREE,Y-5)     /* Free:XX */
    call GOTOXY 2 17+Y*3; XX = charout(,left(strip(VOLID),Y-6)) /* VOL:XX */
  end
return

DISPITREE: procedure expose COL CCLR. CURRENT PTREE. TATTR. DRV TREE. ,
                            TNR IDX. TOTAL FREE VOLID TREELS. TREELNAME.,
                            DEBUGQ DEBUG ROW
  arg OPT
  II = IDX.DRV.TNR
  FI = COL - 34; if FI < 0 then FI = 0
  TY = COL - 13; if TY < 0 then TY = 0
  call GOTOXY 4 13
  XX = charout(,CCLR.0||left(left(TREE.DRV.II,16)||'  '||,
               subword(TREE.DRV.II,4,1),FI))
  CU = COL - 32; if CU < 0 then CU = 0
  call GOTOXY 3 8; XX = charout(,KJADJ(left(PTREE.DRV.II,CU)))  /* Path=XX */
  call GOTOXY 5 12
  if symbol('TREELNAME.DRV.II') <> 'VAR' | TREELNAME.DRV.II = '' then
     XX = charout(,left(' TREE READ FROM:' TREELS.DRV,TY))
  else XX = charout(,KJADJ(left(TREELNAME.DRV.II,TY)))
  if OPT = '' then do
    call GOTOXY 4 COL-24; XX = charout(,copies(' ',4))   /* XX Marked */
    call GOTOXY 4 COL-14; XX = charout(,copies(' ',13))  /* Marked XX */
    call GOTOXY 3 COL-24; XX = charout(,copies(' ',4))   /* XX Files */
    call GOTOXY 3 COL-15; XX = charout(,copies(' ',14))  /* Files XX */
    Y = (COL - 9) % 4
    call GOTOXY 2 19; XX = charout(,right(TOTAL,Y-6))    /* Total:XX */
    call GOTOXY 2 18+Y; XX = charout(,right(TOTAL-FREE,Y-5)) /* Used:XX */
    call GOTOXY 2 18+Y+Y; XX = charout(,right(FREE,Y-5))     /* Free:XX */
    call GOTOXY 2 17+Y*3; XX = charout(,left(VOLID,Y-6)) /* VOL:XX */
  end
return

DISPFRAME: procedure expose ROW COL CCLR.0 CCLR.1 CCLR.2,    /* Draw frame */
                            CUL CH CUR CV CVL CVR CLL CLR TITLE,
                            DEBUGQ DEBUG
  call SysCurState 'OFF'
  YY = COL - 3
  call GOTOXY 1 1
  Z=charout(,CCLR.1||CUL||copies(CH,YY)||CUR||'0D'X||'0A'X)          /**/
  Z=charout(,CV||CCLR.0||copies(' ',YY)||CCLR.1||CV||'0D'X||'0A'X)   /*DRIVE       */
  Z=charout(,CV||CCLR.0||copies(' ',YY)||CCLR.1||CV||'0D'X||'0A'X)   /*Path=       */
  Z=charout(,CV||CCLR.0||copies(' ',YY)||CCLR.1||CV||'0D'X||'0A'X)   /*File Info:  */
  Z=charout(,CV||CCLR.0||copies(' ',YY)||CCLR.1||CV||'0D'X||'0A'X)   /*Ext Attrib: */
  Z=charout(,CVL||copies(CH,YY)||CCLR.1||CVR||'0D'X||'0A'X)          /**/
  do I = 8 to ROW                                                    /* File area  */
    Z=charout(,CV||CCLR.0||copies(' ',YY)||CCLR.1||CV||'0D'X||'0A'X) /* File area  */
  end /* do */                                                       /* File area  */
  X = charout(,CLL||copies(CH,YY)||CCLR.1||CLR)                      /**/
  call GOTOXY 2 2; Z = charout(,CCLR.2||' PAGE:')
  call GOTOXY 2 13; Z = charout(,'Total:')
  Y = (COL - 9) % 4
  call GOTOXY 2 13+Y; Z = charout(,'Used:')
  call GOTOXY 2 13+Y+Y; Z = charout(,'Free:')
  call GOTOXY 2 13+Y*3; Z = charout(,'VOL:')
  call GOTOXY 3 2; Z = charout(,' Path=')
  call GOTOXY 4 2; Z = charout(,' File Info:')
  call GOTOXY 5 2; Z = charout(,' Comments:')
  call GOTOXY 3 COL-20; Z = charout(,'Files')
  call GOTOXY 4 COL-20; Z = charout(,'Marked')
  TL = length(TITLE); Y = (YY - TL)%2; if Y < 1 then Y = 1
  if TL > YY then TL = YY
  call GOTOXY 1 2+Y; Z = charout(,CCLR.1||left(TITLE,TL))
  call GOTOXY ROW 4; X = charout(,' F1,?:HELP ')
  call GOTOXY ROW 17; X = charout(,' F10,$:SETUP ')
  call GOTOXY ROW 32; X = charout(,' F11:EDIT EA.COMMENTS ')
return

SETCOLOR: procedure expose CCLR. ROW DEBUGQ DEBUG
  arg NUM
  do I = 1 to NUM
     parse upper value CCLR.I with X
     XX = '1B'X||'[0;'; P = 2
     if left(CCLR.I,1) = 'H' then XX = XX||'1;'
     else P = 1
     call GETC substr(X,P,2); XX = XX||result
     call GETC substr(X,P+2,2)
     if result <> '' then result = ';'||(result + 10)
     XX = XX||result||'m'
     CCLR.I = XX
  end /* do */
return

GETC: procedure
  arg CC
  select
     when CC = 'BK' then VL = 30
     when CC = 'RE' then VL = 31
     when CC = 'GR' then VL = 32
     when CC = 'YE' then VL = 33
     when CC = 'BL' then VL = 34
     when CC = 'PU' then VL = 35
     when CC = 'TU' then VL = 36
     when CC = 'WH' then VL = 37
     when CC = 'RV' then VL = 7
     otherwise VL = ''
  end  /* select */
return VL

SETPARM:
  FSORTKEY = 'NONE'
  FSORTORD = 'N'
  EALIST.1 = '.LONGNAME'
  EALIST.2 = '.COMMENTS'
  EALIST.3 = '.SUBJECT'
  EALIST.4 = '.KEYPHRASES'
  EALIST.0 = 4
  /* ALT code table */
  ALTT. = '' ; ALTT.1E='A'; ALTT.30='B'; ALTT.2E='C'; ALTT.20='D'
  ALTT.12='E'; ALTT.21='F'; ALTT.22='G'; ALTT.23='H'; ALTT.17='I'
  ALTT.24='J'; ALTT.25='K'; ALTT.26='L'; ALTT.32='M'; ALTT.31='N'
  ALTT.18='O'; ALTT.19='P'; ALTT.10='Q'; ALTT.13='R'; ALTT.1F='S'
  ALTT.14='T'; ALTT.16='U'; ALTT.2F='V'; ALTT.11='W'; ALTT.2D='X'
  ALTT.15='Y'; ALTT.2C='Z'; ALTT.81='0'; ALTT.58='1'; ALTT.59='2'
  ALTT.5A='3'; ALTT.7B='4'; ALTT.7C='5'; ALTT.7D='6'; ALTT.7E='7'
  ALTT.7F='8'; ALTT.80='9'
  /* Code page test. Thanks Altair san */
  options 'exmode'
  if NETMODE = 1 then do
     CUL = '+'; CH = '-'; CUR ='+'            /*     */
     CV = '|'                                 /*   */
     CVL = '+'; CVR = '+'                     /*    */
     CLL = '+'; CLR = '+'                     /*    */
  end  /* Do */
  else do
    if filespec('N','\') = '\' then do
       CUL = '1'x; CH = '6'x; CUR ='2'X             /*     */
       CV = '5'x                                    /*   */
       CVL = '19'x; CVR = '17'x                     /*    */
       CLL = '3'X; CLR = '4'X                       /*    */
    end  /* Do */
    else do
       CUL = 'C9'x; CH = 'CD'x; CUR ='BB'x          /*     */
       CV = 'BA'x                                   /*   */
       CVL = 'CC'x; CVR = 'B9'x                     /*    */
       CLL = 'C8'x; CLR = 'BC'x                     /*    */
    end  /* Do */
  end
  options 'noexmode'
return

DISPFILE: procedure expose FST ROW COL FILE. LFILE TYPE. DISPMODE ATTR. LL,
                           LBL FLM CCLR. NX NY NR LNR FNAME. MASK. LFL,
                           FCOUNT FIDX. INR LNAME. CDROM. DEBUGQ DEBUG
arg OPT
  if NR < 1 then NR = 1                   /* NR adjust in case of no-files */
  INR = FIDX.NR
  if OPT <> '' then do                    /* partial update */
    call DISPFILEX NR
    call DISPFILEX LNR
  end  /* Do */
  else do                                  /* full update */
    NY = (COL-3) % LFILE; if NY < 1 then NY = 1
    LL = (COL-3) % NY; NYR = (COL-3) // LL; NX = ROW - 7
    if NR > FST + NX * NY - 1 then do      /* NR is out side of screen */
       FST = NR - NX * NY + 1
       if FST < 1 then FST = 1
       INR = FIDX.NR
    end  /* Do */
    LBL = format(NYR,,0); TBL = NYR - LBL
    PP = (NR%(NX*NY))+1||'/'||(format((FCOUNT-1)/(NX*NY)+0.5,,0))
    call GOTOXY 2 8; Z = charout(,CCLR.0||left(PP,5))  /* Display page count */
    if FLM < (COL-3)/2 then LFL = FLM + 1
    else LFL = format((COL - 3) / 2,,0)
    XLINE. = CCLR.0||COPIES(' ',LBL)
    do YY = 0 to NY - 1
      do XX = 0 to ROW - 8
        I = FST + XX + YY * (ROW - 7)
        call BLDLINE I
        XLINE.XX = XLINE.XX||result
      end
    end /* do */
    do X = 7 to ROW - 1
       call GOTOXY X 2
       XX = X - 7
       Z = charout(,XLINE.XX||copies(' ',TBL))
    end
  end /* do */
  LNR = NR                                 /* Lagging NR */
return

DISPFILEX: procedure expose INR DISPMODE LFILE FILE. TYPE. COL LL LBL CDROM. ,
                            ATTR. ROW FST CCLR. FNAME. MASK. LFL FIDX. ,
                            LNAME. FCOUNT ROW DEBUGQ DEBUG
  arg I .
  XX = (I - FST) // (ROW - 7); YY = (I - FST) % (ROW - 7)
  call GOTOXY 7+XX LBL+(LL*YY)+2
  call BLDLINE I
  Z = charout(,result)
return

BLDLINE: procedure expose LL MASK. FILE. FNAME. TYPE. COL LFL LFILE ATTR. ,
                          INR CCLR. DISPMODE FCOUNT FST FIDX. LNAME. CDROM.,
                          ROW DEBUGQ DEBUG
  arg J .
  I = FIDX.J
  if I <= FCOUNT & '' <> I then do
    if left(DISPMODE,1) = 1 then do
      select
         when symbol('CDROM.I') = 'VAR' then LINE = CDROM.I
         when TYPE.I <> '' then LINE = TYPE.I
      otherwise
         LINE = LNAME.I
      end  /* select */
      select
         when right(DISPMODE,1) = 'A' then LINE = KJADJ(left(MASK.I||FNAME.I,LFL)) left(FILE.I,11) LINE
         when right(DISPMODE,1) = 'B' then LINE = KJADJ(left(MASK.I||FNAME.I,LFL)) left(FILE.I,20) LINE
         when right(DISPMODE,1) = 'C' then LINE = KJADJ(left(MASK.I||FNAME.I,LFL)) left(FILE.I,26) LINE
      otherwise
         LINE = KJADJ(left(MASK.I||FNAME.I,LFL)) FILE.I LINE
      end  /* select */
    end  /* Do */
    else LINE = left(MASK.I||KJADJ(left(FNAME.I,12))||substr(FILE.I,3), LFILE)
    if length(LINE) > COL - 3 then LINE = left(LINE,COL-3)
    select
      when substr(ATTR.I,5)='S'   & INR <> I then AT = CCLR.3
      when substr(ATTR.I,3,1)='H' & INR <> I then AT = CCLR.4
      when substr(ATTR.I,4,1)='R' & INR <> I then AT = CCLR.5
      when substr(ATTR.I,2,1)='D' & INR <> I then AT = CCLR.6
      when substr(ATTR.I,5)='S'   & INR = I then AT = CCLR.13
      when substr(ATTR.I,3,1)='H' & INR = I then AT = CCLR.14
      when substr(ATTR.I,4,1)='R' & INR = I then AT = CCLR.15
      when substr(ATTR.I,2,1)='D' & INR = I then AT = CCLR.16
      otherwise do
         if INR <> I then AT = CCLR.7
         else AT = CCLR.19
      end
    end  /* select */
  end  /* Do */
  else do
     LINE = ''; AT = CCLR.0
  end  /* Do */
return AT||KJADJ(left(LINE,LL))

CLS: procedure                           /* Clear screen */
  X = charout(,'1B'x||'[2J')
return

GOTOXY: procedure                        /* Move the cursor */
arg X Y
  /* Z = syscurpos(X, Y) */
  Z = charout(,'1B'X||'['||X||';'||Y||'H')
return

KJTEST: procedure     /* Test a charcter */
parse arg CHR
  if (('81'X<=CHR)&(CHR<='9F'X))|(('E0'X<=CHR)&(CHR<='FC'X)) then KJ = 1
  else KJ = 0
return KJ  /* KJ = 0 : SBCS or DBCS-2,  KJ = 1 : DBCS-1 or DBCS-2 */

KJTEST2: procedure
parse arg LINE
  LEN = length(LINE)
  do I = 0 to LEN - 1  /* Look for SBCS or DBCS-2 form right */
     if 0 = KJTEST(substr(LINE,LEN-I,1)) then leave
  end /* do */
  parse value I/2 with . '.' ODD
  if ODD = '' then return 0
return 1   /* Return 0 = SBCS or DBCS-2, 1 =  DBCS-1 */

KJADJ: procedure  /* suppress incomplete DBCS charcter */
parse arg LINE
  if KJTEST2(LINE) = 0 then return LINE
return left(LINE,length(LINE)-1)||' '

EAANAL: procedure expose EASTEM. ROW DEBUGQ DEBUG
parse arg EA
  EASTEM. = ''
  P = pos('DFFF'x,EA)
  if P = 0 then LL = 1
  else LL = c2d(substr(EA,P+5,1)) * 256 + c2d(substr(EA,P+4,1)) /* # of lines */
  IX = 0
  do I = 1 to LL
     P = pos('FDFF'x,EA)
     if P = 0 then leave
     LEN = c2d(substr(EA,P+3,1)) * 256 + c2d(substr(EA,P+2,1))  /* Length */
     LINE = substr(EA,P+4,LEN)
     if right(LINE,1) = '0D'x then LINE = left(LINE,LEN-1) /* for OS/2 V2.1 */
     do forever
        PP = verify(LINE,'0D0A'x,'M')  /* Look for 0D or 0A */
        if PP = 0 then leave
        IX = IX + 1
        EASTEM.IX = left(LINE,PP-1)
        if '0D0A'x = substr(LINE,PP,2) then PP = PP + 1
        LINE = substr(LINE,PP+1)
     end  /* Do */
     IX = IX + 1
     EASTEM.IX = LINE
     EA = substr(EA,P+4+LEN)
  end /* do */
  EASTEM.0 = IX
return

QUERYFILE: procedure expose ROW DEBUGQ DEBUG
parse arg FN
  RC = SysFileTree(FN,'FILE','F')
  if FILE.0 = 0 then do
     RC = SysFileTree(FN,'FILE','D')
     if FILE.0 = 0 then RC = 2 /* No file and no directory */
     else RC = 1               /* Directory is exsist */
  end  /* Do */
  else RC = 0                  /* File is exsist */
return RC

GETALIST: procedure expose ROW DEBUGQ DEBUG ALIST ALIST.
arg OPT .
   P = wordpos(OPT,ALIST)
return ALIST.P

GETAUNPK: procedure expose ROW DEBUGQ DEBUG AUNPK AUNPK.
arg OPT .
   P = wordpos(OPT,AUNPK)
return AUNPK.P

PUTALIST: procedure expose ROW DEBUGQ DEBUG ALIST ALIST.
parse arg EXT,CMD
   parse upper value EXT with EXT
   P = wordpos(EXT,ALIST)
   if P = 0 then do
      ALIST = ALIST EXT
      X = words(ALIST)
      ALIST.X = CMD
   end  /* Do */
   else ALIST.P = CMD
return

PUTAUNPK: procedure expose ROW DEBUGQ DEBUG AUNPK AUNPK.
parse arg EXT,CMD
   parse upper value EXT with EXT
   P = wordpos(EXT,AUNPK)
   if P = 0 then do
      AUNPK = AUNPK EXT
      X = words(AUNPK)
      AUNPK.X = CMD
   end  /* Do */
   else AUNPK.P = CMD
return

DOCMD: procedure expose RC ROW DEBUGQ DEBUG
parse arg OPT,XCMD
   XCMD
   parse value SysCurPos() with . CC
   if CC <> 0 then say ''
   if RC <> 0 then call DEBUGSAY 'x','RC='RC ' CMD='XCMD
   if OPT = '' | RC <> 0 then do
      XX = charout(,'Press enter key to return')
      pull XX
   end
return RC

EXECUTE: procedure expose ROW DEBUGQ DEBUG
parse arg FILENAME , PARM , CMD
  ECMD = ''
  SUB = 0
  do forever
     P = pos('%',CMD)
     if P = 0 then leave
     ECMD = ECMD||left(CMD,P-1)
     parse upper value substr(CMD,P+1,1) with X
     select
        when X = 'F' then do  /* substiation %f */
           ECMD = ECMD||FILENAME
           CMD = substr(CMD,P+2)
           SUB = 1
        end  /* Do */
        when X = 'A' | X = 'D' then do  /* %a and %d */
           ECMD = ECMD||PARM
           CMD = substr(CMD,P+2)
        end  /* Do */
     otherwise
       ECMD = ECMD||'%'
       CMD = substr(CMD,P+1)
     end  /* select */
  end /* do */
  ECMD = ECMD||CMD
  if SUB = 0 then ECMD = ECMD FILENAME
  '@'ECMD
  if RC <> 0 then call DEBUGSAY ,'RC='RC 'CMD='ECMD
return RC

SETHELP: procedure expose HLP. VER DATE ROW DEBUGQ DEBUG
arg OPT
   HLP. = ''; I = 0
   select
      when OPT = 'FINFO' then do
       I=I+1; HLP.I = 'F1, ?   : HELP'
       I=I+1; HLP.I = 'F11     : EDIT EA COMMENTS'
       I=I+1; HLP.I = 'Esc,  Q : Quit'
       I=I+1; HLP.I = 'PgDn, N : Next Item'
       I=I+1; HLP.I = 'PgUp, P : Previous Item'
       I=I+1; HLP.I = 'Down Arrow, F, Enter'
       I=I+1; HLP.I = '            : Forward'
       I=I+1; HLP.I = 'Up Arrow, B : Backward'
       I=I+1; HLP.I = 'Other keys  : Page Forward'
       HLP.0 = I 30                            /* Count and length */
     end  /* Do */
     when OPT = 'TREE' then do
       I=I+1; HLP.I = 'PgUp, PgDn, Up/Down arrow'
       I=I+1; HLP.I = 'F1, ?        : HELP'
       I=I+1; HLP.I = '\            : Top'
       I=I+1; HLP.I = 'Home         : Top'
       I=I+1; HLP.I = 'End          : Bottom'
       I=I+1; HLP.I = 'Enter        : CD & quit'
       I=I+1; HLP.I = 'F            : Find'
       I=I+1; HLP.I = 'L            : Log drive'
       I=I+1; HLP.I = 'Q, Esc       : Quit'
       I=I+1; HLP.I = 'R            : Force read'
       I=I+1; HLP.I = 'W            : Write info'
       I=I+1; HLP.I = 'ALT+alphabet : Search'
       HLP.0 = I 28                            /* Count and length */
     end  /* Do */
   otherwise
     I=I+1; HLP.I = 'FD/2 Version' VER DATE
     I=I+1; HLP.I = ''
     I=I+1; HLP.I = 'F1, ? : HELP'
     I=I+1; HLP.I = 'F10,$ : SETUP'
     I=I+1; HLP.I = 'F11   : EDIT EA COMMENTS FIELD'
     I=I+1; HLP.I = '1 : File display mode 1'
     I=I+1; HLP.I = '2 : File display mode 2'
     I=I+1; HLP.I = '3 : File display mode 3'
     I=I+1; HLP.I = '5 : File display mode 5'
     I=I+1; HLP.I = 'A : Attrib'
     I=I+1; HLP.I = 'C : Copy'
     I=I+1; HLP.I = 'D : Delete (Files & Directories)'
     I=I+1; HLP.I = 'E : Edit'
     I=I+1; HLP.I = 'F : Find'
     I=I+1; HLP.I = 'H : sHell command'
     I=I+1; HLP.I = 'I : file Information'
     I=I+1; HLP.I = 'K : maKe directory'
     I=I+1; HLP.I = 'L : Log drive'
     I=I+1; HLP.I = 'M : Move'
     I=I+1; HLP.I = 'P : Pack'
     I=I+1; HLP.I = 'Q : Quit'
     I=I+1; HLP.I = 'R : Rename'
     I=I+1; HLP.I = 'S : Sort'
     I=I+1; HLP.I = 'T : Tree'
     I=I+1; HLP.I = 'U : Unpack'
     I=I+1; HLP.I = 'V : View'
     I=I+1; HLP.I = 'X : eXecute'
     I=I+1; HLP.I = '* : Find & Mark'
     I=I+1; HLP.I = '\       : CD \ (Thanks Alatir san)'
     I=I+1; HLP.I = 'BS      : CD ..'
     I=I+1; HLP.I = 'Space   : Mark/unmark current file'
     I=I+1; HLP.I = 'Home    : Mark/unmark all files'
     I=I+1; HLP.I = 'End     : Reverse mark/unmark files'
     I=I+1; HLP.I = 'Enter   : View/CD/List'
     I=I+1; HLP.I = 'CTR+Enter : EDIT/Execute/Unpack'
     I=I+1; HLP.I = 'ALT+Alph/Num : Search'
     HLP.0 = I 37                            /* Count and length */
   end  /* select */
return

DISPHELP: procedure expose COL ROW CCLR. CUL CUR CH CV CLL CLR HLP.,
                           DEBUGQ DEBUG
   parse value HLP.0 with CC LL
   YPOS = COL - LL - 5
   if YPOS < 0 then do; YPOS = 2; LL = COL - 6; end
   P = 1; LL1 = (LL - 8) % 2; LL2 = LL - LL1 - 8
   do until P > CC
      call GOTOXY 7 YPOS
      Z = charout(,CCLR.8||CUL||copies(CH,LL1)||'[ HELP ]'||,
                   copies(CH,LL2)||CUR||CCLR.0||' ')
      do XX = 8 to (ROW - 4)
         call GOTOXY XX YPOS
         X = charout(,CCLR.8||CV left(HLP.P,LL-2) CV||CCLR.9||' ')
         P = P + 1
      end /* do */
      call GOTOXY ROW-3 YPOS
      X = charout(,CCLR.8||CLL||copies(CH,LL)||CLR||CCLR.9||' ')
      if P < (CC + 1) then do
          call GOTOXY ROW-3 YPOS+LL-7; X = charout(,CCLR.8 'more.. ')
      end  /* Do */
      call GOTOXY ROW-2 YPOS+1; X = charout(,CCLR.9||copies(' ',LL+2))
      KEY = sysgetkey('NOECHO')
      if KEY = '00'X | KEY = 'E0'X then KEY = sysgetkey('NOECHO')
      if KEY = '1B'X then leave
   end
return

READINI:
  do while lines(INIPATH) > 0
     parse value LINEIN(INIPATH) with L1 '=' R
     R = strip(R)
     parse value L1 with L1 '.' L2
     select
        when L1 = 'LONGNAMEMODE' then LONGNAMEMODE = R
        when L1 = 'CDROMINDEX' then CDROMINDEX = R
        when L1 = 'EACOMMENTS' then EACOMMENTS = R
        when L1 = 'PM_EDITOR' then PM_EDITOR = R
        when L1 = 'PM_VIEWER' then PM_VIEWER = R
        when L1 = 'NET_EDITOR' then NET_EDITOR = R
        when L1 = 'NET_VIEWER' then NET_VIEWER = R
        when L1 = 'APACK' then APACK = R
        when L1 = 'DISPMODE' then DISPMODE = R
        when L1 = 'DISPMODE1SAV' then DISPMODE1SAV = R
        when L1 = 'ALIST' then call PUTALIST L2, R
        when L1 = 'AUNPK' then call PUTAUNPK L2, R
     otherwise nop
     end  /* select */
  end /* do */
  x = stream(INIPATH,'c','close')
return

WRITEINI:
   RC = SysFileDelete(INIPATH)
   if RC = 0 | RC = 2 then do
      call lineout INIPATH, '/* FD/2 INI FILE' VER DATE('O') TIME() INIPATH '*/'
      call lineout INIPATH, "LONGNAMEMODE =" LONGNAMEMODE
      call lineout INIPATH, "CDROMINDEX   =" CDROMINDEX
      call lineout INIPATH, "EACOMMENTS   =" EACOMMENTS
      call lineout INIPATH, "PM_EDITOR    =" PM_EDITOR
      call lineout INIPATH, "PM_VIEWER    =" PM_VIEWER
      call lineout INIPATH, "NET_EDITOR   =" NET_EDITOR
      call lineout INIPATH, "NET_VIEWER   =" NET_VIEWER
      call lineout INIPATH, "APACK        =" APACK
      call lineout INIPATH, "DISPMODE     =" DISPMODE
      call lineout INIPATH, "DISPMODE1SAV =" DISPMODE1SAV
      do I = 1 to words(ALIST)
         call lineout INIPATH, "ALIST."||word(ALIST,I) "   =" GETALIST(word(ALIST,I))
      end /* do */
      do I = 1 to words(AUNPK)
         call lineout INIPATH, "AUNPK."||word(AUNPK,I) "   =" GETAUNPK(word(AUNPK,I))
      end /* do */
      call lineout INIPATH
   end  /* Do */
   else do
      call CLS
      call DEBUGSAY 'x','FD/2 INI file write error.  RC =' RC ' File Name =' INIPATH
      pull X
   end  /* Do */
return

DEBUGSAY: procedure expose DEBUGQ DEBUG
  parse arg OPT,X
  if OPT <> '' then say X
  if DEBUG = 1 then do
     OQ = RXQUEUE('Set',DEBUGQ)
     queue X
     call RXQUEUE 'Set',OQ
  end  /* Do */
return

DEBUGMODE:
   DEBUGQ = RXQUEUE('Create')
   'start "FD/2 Debug Window" /F FD2DEBUG.CMD' DEBUGQ
   DEBUG = 1
return

FD2DLLCHK:
   say 'FD2.DLL is not installed.'
   FD2DLL = 1
return

delimit3:procedure; parse arg x,limit
  y=''; n=length(x)
  do while n>3
    n=n-3
    y=','right(x,3)y
    x=left(x,n)
  end
  y=x||y; n=length(y)
  select
    when n>limit+3 then y=left(y,n-8)'M'
    when n>limit then y=left(y,n-4)'K'
    otherwise nop
  end
  return right(y,limit)
