/* fd2.c   Copyright (c) 1996 by Nob_Kozawa  PAF00521@niftyserv.or.jp */
#define INCL_DOSDEVIOCTL
#include <os2.h>
#include <os2emx.h>
#include <stdlib.h>
#include <string.h>

/* load all routines */
ULONG rxfd2_loadfuncs (PCSZ name, LONG argc, const RXSTRING *argv,
                       PCSZ queuename, PRXSTRING retstr)
{
  retstr->strlength = 0;
  if (argc != 0)
    return (1);
  RexxRegisterFunctionDll ("RXFD2VER", "FD2", "RXFD2VER");
  RexxRegisterFunctionDll ("RXGETDEVPARM", "FD2", "RXGETDEVPARM");
  RexxRegisterFunctionDll ("RXGETSHIFTSTATE", "FD2", "RXGETSHIFTSTATE");
  return (0);
}

ULONG rxfd2_ver (PCSZ name, LONG argc, const RXSTRING *argv,
                 PCSZ queuename, PRXSTRING retstr)
{
  retstr->strlength = 0;
  MAKERXSTRING (*retstr,
  "FD2.DLL 1.0 Copyright (c) 1996 by Nob_Kozawa PAF00521@niftyserve.or.jp", 70);
  return (0);
}

/************************************************************************
   RxGetDevParm   96/06/14  Nob_Kozawa PAF00521@niftyserv.or.jp
   Input parameter : drive letter
                     This routine checks 1st byte of 1st parameter only.
   output : raw data of ioctl (category 0x8, function 0x63) return value
            if ioctl function returns non-0 return code,
            null string will be returned.
*************************************************************************/
ULONG rx_getdevparm(PCSZ name, LONG argc, const RXSTRING *argv,
                    PCSZ queuename, PRXSTRING retstr)
{
   HFILE  hfDevHandle;
   ULONG  ulCategory;
   ULONG  ulFunction;
   PVOID  pvParmList;
   ULONG  ulParmLengthMax;
   PULONG pulParmLengthInOut;
   PVOID  pvDataArea;
   ULONG  ulDataLengthMax;
   PULONG pulDataLengthInOut;
   APIRET rc;
   UCHAR  ucParm[] = {0, 2};
   UCHAR  ucData[50];
   char   *opt;

   retstr->strlength = 0;
   if (argc < 1 || RXNULLSTRING (argv[0])) return (0);
   opt = RXSTRPTR(argv[0]);
   ucParm[1] = (opt[0] & 0xdf) - 'A';

   rc = DosDevIOCtl( -1,                /* hfDevHandle */
                     IOCTL_DISK,        /* ulCategory = 0x8  */
                     DSK_GETDEVICEPARAMS,     /* ulFunction = 0x63 */
                     pvParmList = (PVOID)ucParm,
                     ulParmLengthMax = 2,
                     pulParmLengthInOut = &ulParmLengthMax,
                     pvDataArea = (PVOID)ucData,
                     ulDataLengthMax = 36,
                     pulDataLengthInOut = &ulDataLengthMax);

   if (0 == rc) MAKERXSTRING (*retstr, ucData, 36);
/*   else printf("Err %d\n",rc); */
   return (0);
}

/************************************************************************
   RxGetShiftState   96/06/14  Nob_Kozawa PAF00521@niftyserv.or.jp
   Input parameter : None
   output : raw data of ioctl (category 0x4, function 0x73) return value
            if ioctl function returns non-0 return code,
            null string will be returned.
*************************************************************************/
ULONG rx_getshiftstate(PCSZ name, LONG argc, const RXSTRING *argv,
                    PCSZ queuename, PRXSTRING retstr)
{
   HFILE  hfDevHandle;
   ULONG  ulCategory;
   ULONG  ulFunction;
   PVOID  pvParmList;
   ULONG  ulParmLengthMax;
   PULONG pulParmLengthInOut;
   PVOID  pvDataArea;
   ULONG  ulDataLengthMax;
   PULONG pulDataLengthInOut;
   APIRET rc;
   UCHAR  ucParm[] = {0};
   UCHAR  ucData[3];
   ULONG  ulActionTaken;

   retstr->strlength = 0;

   rc = DosOpen( (PSZ)"KBD$",
                 &hfDevHandle,
                 &ulActionTaken,
                 0, 0,
                 OPEN_ACTION_OPEN_IF_EXISTS,
                 OPEN_SHARE_DENYNONE,
                 (PEAOP2) NULL);

/*   if (0 != rc) printf ("DosOpen %d",rc); */

   rc = DosDevIOCtl( hfDevHandle,
                     IOCTL_KEYBOARD,        /* ulCategory = 0x4  */
                     KBD_GETSHIFTSTATE,     /* ulFunction = 0x73 */
                     pvParmList = (PVOID)ucParm,
                     ulParmLengthMax = 1,
                     pulParmLengthInOut = &ulParmLengthMax,
                     pvDataArea = (PVOID)ucData,
                     ulDataLengthMax = 3,
                     pulDataLengthInOut = &ulDataLengthMax);

   if (0 == rc) 
      MAKERXSTRING (*retstr, ucData, 3);
/*   else printf("Error %d\n",rc); */

   rc = DosClose(hfDevHandle);
/*   if (0 != rc) printf ("DosClose %d",rc); */

   return (0);
}

